# MAT.jl
[![CI](https://github.com/JuliaIO/MAT.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaIO/MAT.jl/actions/workflows/CI.yml)

[![docs-stable][docs-stable-img]][docs-stable-url]
[![docs-dev][docs-dev-img]][docs-dev-url]

### Read and write MATLAB files in Julia

This library can read MATLAB `.mat` files, both in the older v4/v5/v6/v7 format, as well as the newer v7.3 format.

## Installation

This is installed using the standard tools of the [package manager](https://julialang.github.io/Pkg.jl/v1/getting-started/):

```julia
pkg> add MAT
```
where you get the `pkg>` prompt by hitting `]` as the first character of the line. (Exit `pkg` mode by hitting backspace or Ctrl-C as the first character of the line.)

See also the requirements for the [HDF5](https://github.com/timholy/HDF5.jl/) module, used for "v7.3" files and for writing \*.mat files.

## Usage

To load the module:

```julia
using MAT
```

To read a single variable from a MAT file (compressed files are detected and handled automatically):

```julia
file = matopen("matfile.mat")
read(file, "varname") # note that this does NOT introduce a variable ``varname`` into scope
close(file)
```

To write a variable to a MAT file:

```julia
file = matopen("matfile.mat", "w")
write(file, "varname", variable)
close(file)
```

To read all variables from a MAT file as a Dict:

```julia
vars = matread("matfile.mat")
```

To write a Dict to a MAT file, using its keys as variable names.
The `compress` argument is optional, and compression is off by default:

```julia
matwrite("matfile.mat", Dict(
	"myvar1" => 0,
	"myvar2" => 1
); compress = true)
```

To write in MATLAB v4 format:

```julia
matwrite("matfile.mat", Dict(
	"myvar1" => 0,
	"myvar2" => 1
);version="v4")
```

To get a list of variable names in a MAT file:

```julia
file = matopen("matfile.mat")
varnames = keys(file)
close(file)
```

To check for the presence of a variable name in a MAT file:

```julia
file = matopen("matfile.mat")
if haskey(file, "variable")
    # something
end
close(file)
```

## Caveats

* All files are written in MATLAB v7.3 format by default.
* Writing in MATLAB v4 format is provided by the matwrite function with keyword argument.

## Credits

The MAT_HDF5 module, which provides read/write support for MATLAB v7.3 files, was written primarily by [Tim Holy](https://github.com/timholy/). The MAT_v5 module, which provides read support for MATLAB v5/v6/v7 files, was written primarily by [Simon Kornblith](https://github.com/simonster/). The MAT_v4 module, which provides read and write support for MATLAB v4 files, was written primarily by [Victor Saase](https://github.com/vsaase/).


<!-- URLs -->
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaIO.github.io/MAT.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaIO.github.io/MAT.jl/dev

using MAT, Test

function check(filename, result)
    matfile = matopen(filename)
    for (k, v) in result
        @test haskey(matfile, k)
        got = read(matfile, k)
        if !isequal(got, v) || (typeof(got) != typeof(v) && (!isa(got, String) || !(isa(v, String))))
            close(matfile)
            error("""
                Data mismatch reading $k from $filename ($format)

                Got $(typeof(got)):

                $(repr(got))

                Expected $(typeof(v)):

                $(repr(v))
                """)
        end
    end
    @test union!(Set(), keys(matfile)) == union!(Set(), keys(result))
    close(matfile)

    mat = matread(filename)
    if !isequal(mat, result)
        error("""
            Data mismatch reading $filename ($format)

            Got:

            $(repr(mat))

            Expected:

            $(repr(result))
            """)
        close(matfile)
        return false
    end

    return true
end
cd(dirname(@__FILE__))
for filename in readdir("v4")
    endswith(filename, ".mat") || continue
    d = matread("v4/$filename")
    matwrite("v4/tmp.mat", d; version="v4")
    check("v4/tmp.mat", d)
    rm("v4/tmp.mat")
end

# support read var name without '\0', xref https://github.com/JuliaIO/MAT.jl/pull/202
let tmp = "v4/tmp.mat"
    data = rand(1,9);
    open(tmp, "w") do fid
        M, N = size(data);
        data_type = 0;
        name = "testnamelen";
        L = ncodeunits(name)
        write(fid, Int32(data_type));
        write(fid, Int32(M));
        write(fid, Int32(N));
        write(fid, Int32(0));
        write(fid, Int32(L));
        # name is store without null-terminator '\0'
        write(fid, name)
        write(fid, data)
    end
    d = MAT.matread(tmp)
    @test haskey(d, "testnamelen")
    @test first(values(d)) == data
    rm(tmp)
end

# Read zero-dimensional vars
let tmp = "v4/tmp.mat"
    open(tmp, "w") do fid
        name = "testnamelen";
        L = ncodeunits(name)
        write(fid, Int32(0));
        write(fid, Int32(0));
        write(fid, Int32(0));
        write(fid, Int32(0));
        write(fid, Int32(L));
        # name is store without null-terminator '\0'
        write(fid, name)
    end
    d = MAT.matread(tmp)
    @test haskey(d, "testnamelen")
    rm(tmp)
end

execute = isempty(ARGS) || ARGS[1] == "run"

org, repo = :JuliaIO, :MAT
eval(:(using $repo))
using Documenter

# https://juliadocs.github.io/Documenter.jl/stable/man/syntax/#@example-block
ENV["GKSwstype"] = "100"
ENV["GKS_ENCODING"] = "utf-8"

isci = get(ENV, "CI", nothing) == "true"

format = Documenter.HTML(;
    prettyurls = isci,
    edit_link = "main",
    canonical = "https://$org.github.io/$repo.jl/stable/",
    assets = ["assets/custom.css"],
)

makedocs(;
    modules = [MAT],
    authors = "Contributors",
    sitename = "$repo.jl",
    format,
    pages = [
        "Home" => "index.md",
        "Object Arrays" => "object_arrays.md",
        "Types" => "types.md",
        "Methods" => "methods.md",
    ],
    warnonly = [:missing_docs,],
)

if isci
    deploydocs(;
        repo = "github.com/JuliaIO/MAT.jl",
        devbranch = "master",
        devurl = "dev",
        versions = ["stable" => "v^", "dev" => "dev"],
        forcepush = true,
        push_preview = true,
        # see https://$org.github.io/$repo.jl/previews/PR##
    )
end

using MAT, Test
using Dates

@testset "MatlabStructArray" begin
    d_arr = Dict{String, Any}[
        Dict("x"=>[1.0,2.0], SubString("y")=>3.0),
        Dict("x"=>[5.0,6.0], "y"=>[])
    ]
    s_arr = MatlabStructArray(d_arr)
    @test s_arr["y"][2] == d_arr[2]["y"]
    @test s_arr["x"][1] == d_arr[1]["x"]

    # constructor errors to protect the user
    @test_throws ErrorException MatlabStructArray(["a", "b"], [[]])
    @test_throws ErrorException MatlabStructArray(["a", "b"], [[],[0.1, 0.2]])

    # equality checks
    @test isequal(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["a"], [[0.1, 0.2]]))
    @test !isequal(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["a"], [[0.1, 0.2]], "TestClass"))
    @test !isequal(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["b"], [[0.1, 0.2]]))
    @test isapprox(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["a"], [[0.1+eps(0.1), 0.2]]))
    @test !isapprox(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["b"], [[0.1, 0.2]]))
    @test !isapprox(MatlabStructArray(["a"], [[0.1, 0.2]]), MatlabStructArray(["a"], [[0.11, 0.2]]))
    # name order shouldn't matter in isapprox
    @test isapprox(MatlabStructArray(["a", "b"], [[0.1], [0.2]]), MatlabStructArray(["b", "a"], [[0.2], [0.1]]))

    # empty struct array constructor
    s_arr = MatlabStructArray(["x", "y"], (0,1))
    @test s_arr["x"] == Matrix{Any}(undef, 0, 1)
    @test s_arr["y"] == Matrix{Any}(undef, 0, 1)
    @test MatlabStructArray(["a"]) == MatlabStructArray(["a"], (0,0))

    # convert to Dict to support easy conversion to legacy read behavior
    s_arr = MatlabStructArray(d_arr)
    d = Dict(s_arr)
    @test d isa Dict{String, Any}
    @test collect(keys(d)) == keys(s_arr)
    @test collect(values(d)) == values(s_arr)
    # Dict like interfaces
    @test length(s_arr) == 2
    @test collect(Dict(s_arr)) == collect(s_arr)
    @test haskey(s_arr, "x")
    @test get(s_arr, "x", nothing) == s_arr["x"]
    @test !haskey(s_arr, "wrong")
    @test get(s_arr, "wrong", nothing) === nothing

    # setindexing
    msg = "field \"z\" not found in MatlabStructArray"
    @test_throws ErrorException(msg) s_arr["z"] = [1.0, 2.0]
    s_arr["x"] = [1.0, 2.0]
    @test s_arr["x"] == Any[1.0, 2.0]
    msg = "size of input is not equal to MatlabStructArray column size"
    @test_throws ErrorException(msg) s_arr["x"] = Any[1.0]
    @test_throws ErrorException(msg) s_arr["x"] = reshape(Any[1.0,2.0], 1, 2)

    # possibility to convert back to dict array via `Array`
    s_arr = MatlabStructArray(d_arr)
    @test Array(s_arr) == d_arr
    d_arr_reshape = reshape(d_arr, 1, 2)
    @test Array(MatlabStructArray(d_arr_reshape)) == d_arr_reshape
    d_symbol = Array{Dict{Symbol,Any}}(MatlabStructArray(d_arr))
    @test d_symbol[2][:x] == d_arr[2]["x"]
    @test Array(MatlabStructArray(d_symbol)) == d_arr
    @test s_arr == MatlabStructArray(d_arr)

    # class object array conversion
    s_arr_class = MatlabStructArray(d_arr, "TestClass")
    c_arr = Array(s_arr_class)
    @test c_arr isa Array{<:MatlabClassObject}
    @test all(c->c.class=="TestClass", c_arr)
    @test MatlabStructArray(c_arr) == s_arr_class
    @test s_arr_class != s_arr

    # test error of unequal structs
    wrong_sarr = Dict{String, Any}[
        Dict("x"=>[1.0,2.0], "y"=>[3.0,4.0]),
        Dict("x"=>[5.0,6.0])
    ]
    msg = "Cannot convert Dict array to MatlabStructArray. All elements must share identical field names"
    @test_throws ErrorException(msg) MatlabStructArray(wrong_sarr)
end

@testset "MatlabStructArray integer indexing" begin
    d_arr = Dict{String, Any}[
        Dict("x"=>[1.0,2.0], SubString("y")=>3.0),
        Dict("x"=>[5.0,6.0], "y"=>[])
    ]
    s_arr = MatlabStructArray(d_arr)
    @test s_arr[1] == Array(s_arr)[1]
    @test s_arr[2] == Array(s_arr)[2]

    s_arr = MatlabStructArray(reshape(d_arr, 1, 2))
    @test s_arr[1] == Array(s_arr)[1]
    @test s_arr[2] == Array(s_arr)[2]

    s_arr = MatlabStructArray(reshape(d_arr, 2, 1))
    @test s_arr[1] == Array(s_arr)[1]
    @test s_arr[2] == Array(s_arr)[2]

    s_arr = MatlabStructArray(reshape(d_arr, 2, 1), "TestClass")
    @test s_arr[1] == Array(s_arr)[1]
    @test s_arr[2] == Array(s_arr)[2]
end

@testset "MatlabClassObject" begin
    d = Dict{String,Any}("a" => 5)
    obj = MatlabClassObject(d, "TestClassOld")
    @test keys(obj) == keys(d)
    @test values(obj) == values(d)
    @test collect(obj) == collect(d)
    @test obj["a"] == d["a"]
    @test haskey(obj, "a")
    @test get(obj, "b", "default") == "default"

    obj["b"] = "str"
    @test obj["b"] == "str"

    c_arr = [MatlabClassObject(d, "TestClassOld"), MatlabClassObject(d, "TestClassOld")]
    s_arr = MatlabStructArray(c_arr)
    @test s_arr.class == "TestClassOld"

    wrong_arr = [MatlabClassObject(d, "TestClassOld"), MatlabClassObject(d, "Bah")]
    @test_throws ErrorException MatlabStructArray(wrong_arr)

    d2 = deepcopy(obj.d)
    @test obj == MatlabClassObject(d2, "TestClassOld")
    @test obj != MatlabClassObject(obj.d, "Banana")
    d2["a"] = 5.0 + 1e-9
    @test obj != MatlabClassObject(d2, "TestClassOld")
    @test obj ≈ MatlabClassObject(d2, "TestClassOld")
    @test !(obj ≈ MatlabClassObject(d2, "Banana"))
end

@testset "MatlabOpaque string" begin
    dat = UInt64[
        0x0000000000000001
        0x0000000000000002
        0x0000000000000003
        0x0000000000000001
        0x0000000000000005
        0x0000000000000005
        0x0000000000000005
        0x0065006e006f004a
        0x006f007200420073
        0x006d0053006e0077
        0x0000006800740069
    ]
    dat = reshape(dat, 1, length(dat))
    obj = MatlabOpaque(Dict{String, Any}("any" => dat), "string")
    str = MAT.convert_opaque(obj)
    @test size(str) == (3,1)
    @test vec(str) == ["Jones", "Brown", "Smith"]

    # single element string array is a single string in matlab, ofcourse
    dat = [
        0x0000000000000001
        0x0000000000000002
        0x0000000000000001
        0x0000000000000001
        0x0000000000000005
        0x0065006e006f004a
        0x0000000000000073
    ]
    dat = reshape(dat, 1, length(dat))
    obj = MatlabOpaque(Dict{String, Any}("any" => dat), "string")
    str = MAT.convert_opaque(obj)
    @test str == "Jones"
end

@testset "MatlabOpaque datetime" begin
    @testset "datetime array" begin
        d = Dict{String, Any}(
            "tz"         => "",
            "data"       => ComplexF64[
                1482192000000.0+0.0im;
                1482278400000.0+0.0im;
                1482364800000.0+0.0im;;
                ],
            "fmt"        => "",
            #"isDateOnly" => true, # Note: "isDateOnly" not available in all versions
        )
        obj = MatlabOpaque(d, "datetime")
        expected_dates = [
            DateTime(2016, 12, 20) # 20-Dec-2016
            DateTime(2016, 12, 21) # 21-Dec-2016
            DateTime(2016, 12, 22) # 22-Dec-2016
        ]
        dt = MAT.convert_opaque(obj)
        @test all(dt .== expected_dates)

        obj_conv = MatlabOpaque(dt)
        @test obj_conv == obj
    end

    @testset "datetime element" begin
        d = Dict{String, Any}(
            "tz"         => "",
            "data"       => 1575304969634.0+0.0im,
            "fmt"        => "",
            #"isDateOnly" => false,
        )
        obj = MatlabOpaque(d, "datetime")
        # "02-Dec-2019 16:42:49"
        expected_dt = DateTime(2019, 12, 2, 16, 42, 49)
        # still have some millisecond rounding issue?
        dt = MAT.convert_opaque(obj)
        @test dt - expected_dt < Second(1)

        # convert back to MatlabOpaque
        obj_conv = MatlabOpaque(dt)
        @test obj_conv == obj
    end
end

@testset "MatlabOpaque duration" begin
    d = Dict{String,Any}(
        "millis" => [3.6e6 7.2e6],
        # "fmt"    => 'h' # optional format
    )
    obj = MatlabOpaque(d, "duration")
    ms = MAT.convert_opaque(obj)
    @test ms == map(Millisecond, d["millis"])
    @test MatlabOpaque(ms) == obj

    d = Dict{String,Any}(
        "millis" => 12000.0,
        # "fmt"    => 'h',
    )
    obj = MatlabOpaque(d, "duration")
    ms = MAT.convert_opaque(obj)
    @test ms == Millisecond(d["millis"])
    @test MatlabOpaque(ms) == obj
end

@testset "MatlabOpaque categorical" begin
    d = Dict{String,Any}(
        "isProtected"   => false,
        "codes"         => reshape(UInt8[0x02, 0x03, 0x01, 0x01, 0x01, 0x02], 3, 2),
        "categoryNames" => Any["Fair"; "Good"; "Poor";;],
        "isOrdinal"     => false,
    )
    obj = MatlabOpaque(d, "categorical")

    c = MAT.convert_opaque(obj)
    @test c == [ 
        "Good"  "Fair"
        "Poor"  "Fair"
        "Fair"  "Good"
    ]
    
end

@testset "MatlabOpaque table" begin
    # simplified table struct; there's some other properties as well
    d = Dict{String,Any}(
        "varnames" => Any["FlightNum" "Customer"],
        "nrows" => 3.0,
        "data"  => reshape(Any[[1261.0; 547.0; 3489.0;;], ["Jones"; "Brown"; "Smith";;]], 1, 2),
        "ndims" => 2.0,
        "nvars" => 2.0,
    )
    obj = MatlabOpaque(d, "table")

    # Note: this should work with DataFrames.DataFrame, but that's a big dependency to add for testing
    t = MAT.convert_opaque(obj; table = MatlabTable)
    @test t.names == [:FlightNum, :Customer]
    @test t[:FlightNum] isa Vector{Float64}
    @test t[:FlightNum] == [1261.0, 547.0, 3489.0]
    @test t[:Customer] isa Vector{String}
    @test t["Customer"] == ["Jones", "Brown", "Smith"]

    t = MAT.convert_opaque(obj; table = MatlabStructArray{1})
    @test t isa MatlabStructArray{1}
    @test t["FlightNum"] == [1261.0, 547.0, 3489.0]
    @test t["Customer"] == ["Jones", "Brown", "Smith"]

    t = MAT.convert_opaque(obj; table = Nothing)
    @test t === obj

    nd_array = reshape(1:12, 2, 3, 2)    

    # ND-arrays as columns
    # Note: does not convert to DataFrame
    d = Dict{String,Any}(
        "varnames" => Any["Floats" "NDArray"],
        "nrows" => 2.0,
        "data"  => reshape(Any[[1261.0; 547.0;;], nd_array], 1, 2),
        "ndims" => 2.0,
        "nvars" => 2.0,
    )
    obj = MatlabOpaque(d, "table")
    t = MAT.convert_opaque(obj; table = MatlabTable)
    @test size(t[:Floats]) == (2,)
    @test size(t[:NDArray]) == (2,3,2)

    # single row table
    d = Dict{String,Any}(
        "varnames" => Any["Age" "Name" "Matrix"],
        "nrows" => 1.0,
        "data"  => reshape([25.0, "Smith", [1.0 2.0]], 1, 3),
        "ndims" => 2.0,
        "nvars" => 2.0,
    )
    obj = MatlabOpaque(d, "table")
    t = MAT.convert_opaque(obj; table = MatlabTable)
    @test t[:Age] == [25.0]
    @test t[:Name] == ["Smith"]
    @test t[:Matrix] == [1.0 2.0]
end

# MAT.jl
# Tools for reading MATLAB v5 files in Julia
#
# Copyright (C) 2012   Timothy E. Holy and Simon Kornblith
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

module MAT

using HDF5, SparseArrays

include("MAT_types.jl")
using .MAT_types

include("MAT_subsys.jl")
include("MAT_HDF5.jl")
include("MAT_v5.jl")
include("MAT_v4.jl")

using .MAT_HDF5, .MAT_v5, .MAT_v4, .MAT_subsys

export matopen, matread, matwrite, @read, @write
export MatlabStructArray, MatlabClassObject, MatlabOpaque, MatlabTable, FunctionHandle

# Open a MATLAB file
const HDF5_HEADER = UInt8[0x89, 0x48, 0x44, 0x46, 0x0d, 0x0a, 0x1a, 0x0a]
function matopen(filename::AbstractString, rd::Bool, wr::Bool, cr::Bool, tr::Bool, ff::Bool, compress::Bool; table::Type=MatlabTable, convert_opaque::Bool=true)
    # When creating new files, create as HDF5 by default
    fs = filesize(filename)
    if cr && (tr || fs == 0)
        return MAT_HDF5.matopen(filename, rd, wr, cr, tr, ff, compress, Base.ENDIAN_BOM == 0x04030201; table=table, convert_opaque=convert_opaque)
    elseif fs == 0
        error("File \"$filename\" does not exist and create was not specified")
    end

    rawfid = open(filename, "r")

    # Check for MAT v4 file
    (isv4, swap_bytes) = MAT_v4.checkv4(rawfid)
    if isv4
        return MAT_v4.matopen(rawfid, swap_bytes)
    end

    # Test whether this is a MAT file
    if fs < 128
        close(rawfid)
        error("File \"$filename\" is too small to be a supported MAT file")
    end

    # Check for MAT v5 file
    seek(rawfid, 124)
    version = read(rawfid, UInt16)
    endian_indicator = read(rawfid, UInt16)
    if (version == 0x0100 && endian_indicator == 0x4D49) ||
       (version == 0x0001 && endian_indicator == 0x494D)
        if wr || cr || tr || ff
            error("creating or appending to MATLAB v5 files is not supported")
        end
        return MAT_v5.matopen(rawfid, endian_indicator; table=table, convert_opaque=convert_opaque)
    end

    # Check for HDF5 file
    for offset = 512:512:fs-8
        seek(rawfid, offset)
        if read!(rawfid, Vector{UInt8}(undef, 8)) == HDF5_HEADER
            close(rawfid)
            return MAT_HDF5.matopen(filename, rd, wr, cr, tr, ff, compress, endian_indicator == 0x494D; table=table, convert_opaque=convert_opaque)
        end
    end

    close(rawfid)
    error("\"$filename\" is not a MAT file")
end

function matopen(fname::AbstractString, mode::AbstractString; compress::Bool = false, kwargs...)
    mode == "r"  ? matopen(fname, true , false, false, false, false, false; kwargs...)    :
    mode == "r+" ? matopen(fname, true , true , false, false, false, compress; kwargs...) :
    mode == "w"  ? matopen(fname, false, true , true , true , false, compress; kwargs...) :
    # mode == "w+" ? matopen(fname, true , true , true , true , false, compress) :
    # mode == "a"  ? matopen(fname, false, true , true , false, true, compress)  :
    # mode == "a+" ? matopen(fname, true , true , true , false, true, compress)  :
    throw(ArgumentError("invalid open mode: $mode"))
end

matopen(fname::AbstractString; kwargs...) = matopen(fname, "r"; kwargs...)

function matopen(f::Function, args...; kwargs...)
    fid = matopen(args...; kwargs...)
    try
        f(fid)
    finally
        close(fid)
    end
end

"""
    matopen(filename [, mode]; compress = false, table = MatlabTable) -> handle
    matopen(f::Function, filename [, mode]; compress = false, table = MatlabTable) -> f(handle)

Mode defaults to `"r"` for read.
It can also be `"w"` for write,
or `"r+"` for read or write without creation or truncation.

Compression on reading is detected/handled automatically; the `compress`
keyword argument only affects write operations.

Use with `read`, `write`, `close`, `keys`, and `haskey`.

Optional keyword argument is the `table` type, for automatic conversion of Matlab tables.
Note that Matlab tables may contain non-vector colums which cannot always be converted to a Julia table, like `DataFrame`.

# Example

```julia
using MAT, DataFrames
filepath = abspath(pkgdir(MAT), "./test/v7.3/struct_table_datetime.mat")
fid = matopen(filepath; table = DataFrame)
keys(fid)

# outputs

1-element Vector{String}:
 "s"

```

Now you can read any of the keys
```
s = read(fid, "s")
close(fid)
s

# outputs

Dict{String, Any} with 2 entries:
  "testDatetime" => DateTime("2019-12-02T16:42:49.634")
  "testTable"    => 3×5 DataFrame…

```
"""
matopen

# Read all variables from a MATLAB file
"""
    matread(filename; table = MatlabTable) -> Dict

Return a dictionary of all the variables and values in a Matlab file,
opening and closing it automatically.

Optionally provide the `table` type to convert Matlab tables into. Default uses a simple `MatlabTable` type.

# Example

```julia
using MAT, DataFrames
filepath = abspath(pkgdir(MAT), "./test/v7.3/struct_table_datetime.mat")
vars = matread(filepath; table = DataFrame)
vars["s"]["testTable"]

# outputs

3×5 DataFrame
 Row │ FlightNum  Customer  Date                 Rating  Comment
     │ Float64    String    DateTime             String  String
─────┼─────────────────────────────────────────────────────────────────────────────────────
   1 │    1261.0  Jones     2016-12-20T00:00:00  Good    Flight left on time, not crowded
   2 │     547.0  Brown     2016-12-21T00:00:00  Poor    Late departure, ran out of dinne…
   3 │    3489.0  Smith     2016-12-22T00:00:00  Fair    Late, but only by half an hour. …
```
"""
function matread(filename::AbstractString; table::Type=MatlabTable, convert_opaque::Bool=true)
    file = matopen(filename; table=table, convert_opaque=convert_opaque)
    local vars
    try
        vars = read(file)
    finally
        close(file)
    end
    vars
end

# Write a dict to a MATLAB file
"""
    matwrite(filename, d::Dict; compress::Bool = false, version::String = "v7.3")

Write a dictionary containing variable names as keys and values as values
to a Matlab file, opening and closing it automatically.
"""
function matwrite(filename::AbstractString, dict::AbstractDict{S, T}; compress::Bool = false, version::String ="v7.3") where {S, T}
    file = nothing
    try
        if version == "v4"
            file = open(filename, "w")
            file = MAT_v4.Matlabv4File(file, false)
            _write_dict(file, dict)
        elseif version == "v7.3"
            file = matopen(filename, "w"; compress = compress)
            _write_dict(file, dict)
        else
            error("writing for \"$(version)\" is not supported")
        end
    finally
        if file !== nothing
            close(file)
        end
    end
end

function _write_dict(fileio, dict::AbstractDict)

    for (k, v) in dict
        local kstring
        try
            kstring = ascii(convert(String, k))
        catch x
            error("matwrite requires a Dict with ASCII keys")
        end
        write(fileio, kstring, v)
    end

    if hasproperty(fileio, :subsystem) && fileio.subsystem !== nothing
        # will always be nothing for MATv4 so we can ignore that case
        subsys_data = MAT_subsys.set_subsystem_data!(fileio.subsystem)
        if subsys_data !== nothing
            MAT_HDF5.write_subsys(fileio, subsys_data)
        end
    end
end

end

using MAT, Test, Dates
using SparseArrays, LinearAlgebra

tmpfile = string(tempname(), ".mat")

function test_write_data(data; approx = false, kwargs...)
    matwrite(tmpfile, data; kwargs...)

    fid = matopen(tmpfile, "r")
    local result
    try
        result = read(fid)
    finally
        close(fid)
    end

    if approx
        @test MAT.MAT_types.dict_isapprox(result, data)
    else
        @test isequal(result, data)
    end
end

function test_write(data; kwargs...)
    test_write_data(data; compress = false, kwargs...)
    test_write_data(data; compress = true, kwargs...)
end

function test_compression_effective(data)
    test_write_data(data; compress = false)
    sizeUncompressed = stat(tmpfile).size
    test_write_data(data; compress = true)
    sizeCompressed = stat(tmpfile).size

    if sizeCompressed >= sizeUncompressed
        error("Compression was not effective")
    end
end

@testset "write error messages" begin
    msg = "writing for \"v7\" is not supported"
    @test_throws ErrorException(msg) matwrite(tmpfile, Dict("s" => 1); version="v7")

    msg = "matwrite requires a Dict with ASCII keys"
    @test_throws ErrorException(msg) matwrite(tmpfile, Dict(:s => 1))
    @test_throws ErrorException(msg) matwrite(tmpfile, Dict(:s => 1); version="v4")
end

test_write(Dict(
    "int8" => Int8(1),
    "uint8" => UInt8(1),
    "int16" => Int16(1),
    "uint16" => UInt16(1),
    "int32" => Int32(1),
    "uint32" => UInt32(1),
    "int64" => Int64(1),
    "uint64" => UInt64(1),
    "single" => Float32(1),
    "double" => Float64(1),
    "logical" => true
))

test_write(Dict(
    "ComplexInt" => Complex{Int}[1 -1 1+1im 1-1im -1+1im -1-1im 1im],
    "ComplexF32" => ComplexF32[1.0 -1.0 1.0+1.0im 1.0-1.0im -1.0+1.0im -1.0-1.0im 1.0im],
    "ComplexF64" => [1.0 -1.0 1.0+1.0im 1.0-1.0im -1.0+1.0im -1.0-1.0im 1.0im],
    "ComplexPair" => [1 2-3im 4+5im]
))
test_write(Dict("ComplexF64" => 1.0im, "ComplexPair" => 2-3im))

test_write(Dict(
    "simple_string" => "the quick brown fox",
    "accented_string" => "thé qüîck browñ fòx",
    "concatenated_strings" => ["this is a string      ", "this is another string"],
    "cell_strings" => Any["this is a string" "this is another string"],
    "empty_string" => String[]
))

test_write(Dict(
    "a" => "Hello, MATLAB! 12345 ~!@#\$%^&*()_+-=[]{};:,.<>/?",
    "b" => "Café naïve résumé — π ≈ 3.14159",
    "c" => "Music symbol: 𝄞  | Gothic letter: 𐍈",
    "d" => "Mixed planes: A Ω Ж 中 😀 🚀 🧬",
    "e" => ["AB", "😀"],
    "f" => reshape(["😀𝄞𐍈🚀" "🚀😀𝄞𐍈" "𝄞𐍈🚀😀" "😀𝄞𐍈🚀" "𐍈🚀😀𝄞" "𝄞𐍈🚀😀"], 2, 3),
    "g" => ["ABC", "DEF"],
))

test_write(Dict(
    "a1x2" => [1.0 2.0],
    "a2x1" => zeros(2, 1)+[1.0, 2.0],
    "a2x2" => [1.0 3.0; 4.0 2.0],
    "a2x2x2" => cat([1.0 3.0; 4.0 2.0], [1.0 2.0; 3.0 4.0], dims=3),
    "empty" => zeros(0, 0),
    "bitarray" => trues(3, 3),
    "string" => "string"
))

# cannot distinguish char from single element string
test_write(Dict("char" => 'a'))
# inconsistent behavior in v4
matwrite(tmpfile, Dict("char" => 'a'), version="v4")
@test matread(tmpfile)["char"] == "a"

test_write(Dict(
    "cell" => Any[1 2.01 "string" Any["string1" "string2"]]
))

s3 = Dict()
for i in 1:526
    s3["field$i"] = i
end

test_write(Dict(
    "s" => Dict(
        "a" => 1.0,
        "b" => [1.0 2.0],
        "c" => [1.0 2.0 3.0]
    ),
    "s2" => Dict("a" => [1.0 2.0]),
    "s3" => s3
))

test_write(Dict(
    "sparse_empty" => sparse(Matrix{Float64}(undef, 0, 0)),
    "sparse_eye" => sparse(1.0I, 20, 20),
    "sparse_logical" => SparseMatrixCSC{Bool,Int}(5, 5, [1:6;], [1:5;], fill(true, 5)),
    "sparse_random" => sparse([0 6. 0; 8. 0 1.; 0 0 9.]),
    "sparse_complex" => sparse([0 6. 0; 8. 0 1.; 0 0 9.]*(1. + 1.0im)),
    "sparse_zeros" => SparseMatrixCSC(20, 20, ones(Int, 21), Int[], Float64[])
))

@test_throws ErrorException test_write(Dict("1invalidkey" => "starts with a number"))
@test_throws ErrorException test_write(Dict("another invalid key" => "invalid characters"))
@test_throws ErrorException test_write(Dict("yetanotherinvalidkeyyetanotherinvalidkeyyetanotherinvalidkeyyetanotherinvalidkey" => "too long"))

struct TestCompositeKind
    field1::AbstractString
end
fid = matopen(tmpfile, "w")
write(fid, "test", TestCompositeKind("test value"))
close(fid)
fid = matopen(tmpfile, "r")
result = read(fid, "test")
close(fid)
@assert result == Dict("field1" => "test value")


fid = matopen(tmpfile, "w")
@test_throws ErrorException write(fid, "1invalidvarname", "1invalidvarvalue")
close(fid)

using DataStructures
sd = SortedDict(Dict(
    "uint16" => UInt16(1),
    "ComplexF64" => [1.0 -1.0 1.0+1.0im 1.0-1.0im -1.0+1.0im -1.0-1.0im 1.0im],
    "simple_string" => "the quick brown fox",
    "a1x2" => [1.0 2.0],
    "sparse_empty" => sparse(Matrix{Float64}(undef, 0, 0))
))
test_write(sd)

# note: compression is NOT effective when the dict contains many duplicate entries
# which are not compressible by themselves!
test_compression_effective(Dict("data" => fill(1.0, 1000)))

# test adjoint/reshape array
test_write(Dict("adjoint_arr"=>[1 2 3;4 5 6;7 8 9]'))
test_write(Dict("reshape_arr"=>reshape([1 2 3;4 5 6;7 8 9]',1,9)))

test_write(Dict("adjoint_arr"=>Any[1 2 3;4 5 6;7 8 9]'))
test_write(Dict("reshape_arr"=>reshape(Any[1 2 3;4 5 6;7 8 9]',1,9)))

@testset "named tuple" begin
    nt = (x = 5, y = Any[6, "string"])
    matwrite(tmpfile, Dict("nt" => nt))
    nt_read = matread(tmpfile)["nt"]
    @test nt_read["x"] == 5
    @test nt_read["y"] == nt.y
end

@testset "tuple" begin
    # NTuple{T}
    t = (5, 6)
    matwrite(tmpfile, Dict("t" => (5, 6)))
    r = matread(tmpfile)["t"]
    @test r == [x for x in t]

    # otherwise cell array
    t = (5, "string")
    matwrite(tmpfile, Dict("t" => t))
    r = matread(tmpfile)["t"]
    @test r == [x for x in t]
end

@testset "symbol" begin
    matwrite(tmpfile, Dict("s" => :symbol))
    r = matread(tmpfile)["s"]
    @test r == "symbol"
end

# test nested struct array - interface via Dict array
@testset "MatlabStructArray writing" begin
    sarr = Dict{String, Any}[
        Dict("x"=>[1.0,2.0], SubString("y")=>3.0),
        Dict("x"=>[5.0,6.0], "y"=>[Dict("a"=>7), Dict("a"=>8)])
    ]
    # we have to test Array size is maintained inside mat files
    sarr = reshape(sarr, 1, 2)
    matwrite(tmpfile, Dict("s_array" => sarr))
    read_sarr = matread(tmpfile)["s_array"]
    @test read_sarr isa MatlabStructArray
    @test read_sarr["y"][2] isa MatlabStructArray

    sarr = Dict{String, Any}[
        Dict("x"=>[1.0,2.0], SubString("y")=>3.0),
        Dict("x"=>[5.0,6.0], "y"=>[])
    ]
    test_write(Dict("s_array" => MatlabStructArray(sarr)))

    empty_sarr = MatlabStructArray(["a", "b", "c"])
    test_write(Dict("s_array" => empty_sarr))

    # old matlab class object array
    carr = MatlabStructArray(["foo"], [[5, "bar"]], "TestClassOld")
    test_write(Dict("class_array" => carr))

    d = Dict{String,Any}("foo" => 5)
    obj = MatlabClassObject(d, "TestClassOld")
    test_write(Dict("tc_old" => obj))

    carr = [MatlabClassObject(d, "TestClassOld"), MatlabClassObject(d, "TestClassOld")]
    matwrite(tmpfile, Dict("class_array" => carr))
    carr_read = matread(tmpfile)["class_array"]
    @test carr_read == MatlabStructArray(carr)

    s_large1 = Dict()
    s_large2 = Dict()
    for i in 1:600
        s_large1["field$i"] = i
        s_large2["field$i"] = i + 1000
    end
    sarr = Dict{String, Any}[s_large1, s_large2]
    # note: name/key order doesn't seem to be preserved for some reason
    test_write(Dict{String,Any}("s_array_large" => MatlabStructArray(sarr)); approx=true)
end

@testset "MatlabOpaque simple" begin
    d = Dict{String,Any}("a" => 1, "b" => Any[1.0, 2.0])
    obj = MatlabOpaque(d, "TestClass")
    var_dict = Dict("var" => obj)

    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, var_dict)
        read_var = matread(tmpfile)

        @test haskey(read_var, "var")
        @test isa(read_var["var"], MatlabOpaque)
        @test read_var["var"].class == obj.class

        @test haskey(read_var["var"], "a")
        @test haskey(read_var["var"], "b")
        @test read_var["var"]["a"] == obj["a"]
        @test isequal(read_var["var"]["b"], obj["b"])
    end
end

@testset "Empty Struct 1x1" begin
    var_dict = Dict("empty_struct" => Dict{String,Any}())
    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, var_dict)
        read_var = matread(tmpfile)

        @test haskey(read_var, "empty_struct")
        @test isa(read_var["empty_struct"], Dict{String,Any})
        @test length(keys(read_var["empty_struct"])) == 0
    end
end

@testset "MatlabOpaque handle" begin
    d = Dict{String,Any}("a" => 1, "b" => Any[1.0, 2.0])
    obj = MatlabOpaque(d, "TestClassHandle")
    var_dict = Dict("var1" => obj, "var2" => obj)

    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, var_dict)
        read_var = matread(tmpfile)

        @test haskey(read_var, "var1")
        @test haskey(read_var, "var2")
        @test isa(read_var["var1"], MatlabOpaque)
        @test isa(read_var["var2"], MatlabOpaque)
        @test read_var["var1"] === read_var["var2"]  # same object
    end
end

@testset "MatlabOpaque Array" begin
    d1 = Dict{String, Any}("a" => 1)
    d2 = Dict{String, Any}("a" => 2)
    obj1 = MatlabOpaque(d1, "TestClassArray")
    obj2 = MatlabOpaque(d2, "TestClassArray")
    obj_arr = Array{MatlabOpaque}(undef, 2, 1)
    obj_arr[1, 1] = obj1
    obj_arr[2, 1] = obj2
    var_dict = Dict("obj_array" => obj_arr)

    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, var_dict)
        read_var = matread(tmpfile)

        @test haskey(read_var, "obj_array")
        @test isa(read_var["obj_array"], Array{MatlabOpaque})
        @test size(read_var["obj_array"]) == (2, 1)
        @test read_var["obj_array"][1, 1]["a"] == 1
        @test read_var["obj_array"][2, 1]["a"] == 2
    end
end

@testset "MatlabOpaque Nested object" begin
    inner_dict = Dict{String,Any}("a" => 1, "b" => 2)
    inner_obj = MatlabOpaque(inner_dict, "InnerClass")
    outer_dict = Dict{String,Any}("inner" => inner_obj, "c" => 3)
    outer_obj = MatlabOpaque(outer_dict, "OuterClass")
    var_dict = Dict("outer_obj" => outer_obj)

    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, var_dict)
        read_var = matread(tmpfile)

        @test haskey(read_var, "outer_obj")
        @test isa(read_var["outer_obj"], MatlabOpaque)
        @test read_var["outer_obj"].class == outer_obj.class

        @test haskey(read_var["outer_obj"], "inner")
        @test haskey(read_var["outer_obj"], "c")
        @test read_var["outer_obj"]["c"] == outer_obj["c"]

        inner_read = read_var["outer_obj"]["inner"]
        @test isa(inner_read, MatlabOpaque)
        @test inner_read.class == inner_obj.class

        @test haskey(inner_read, "a")
        @test haskey(inner_read, "b")
        @test inner_read["a"] == inner_obj["a"]
        @test inner_read["b"] == inner_obj["b"]
    end

end

@testset "Dates" begin
    dt = DateTime[
        DateTime(2016, 12, 20) # 20-Dec-2016
        DateTime(2016, 12, 21) # 21-Dec-2016
        DateTime(2016, 12, 22) # 22-Dec-2016
    ]
    test_write(Dict{String,Any}("dt" => dt))
    test_write(Dict{String,Any}("dt" => dt[1]))

    ms = Millisecond(500)
    test_write(Dict{String,Any}("ms" => ms))
    test_write(Dict{String,Any}("ms" => [ms, Millisecond(50000)]))
end

@testset "function handles" begin
    let objtestfile = "function_handles.mat"
        filepath = joinpath(dirname(@__FILE__), "v7.3", objtestfile)
        vars = matread(filepath)

        mktempdir() do tmpdir
            tmpfile = joinpath(tmpdir, "test.mat")
            matwrite(tmpfile, vars)
            vars_write = matread(tmpfile)

            @test haskey(vars_write, "sin")
            @test haskey(vars_write, "anonymous")

            @test isa(vars_write["sin"], FunctionHandle)
            @test isa(vars_write["anonymous"], FunctionHandle)

            @test Set(keys(vars_write["sin"])) == Set(["function_handle", "sentinel", "separator", "matlabroot"])
            @test Set(keys(vars_write["anonymous"])) == Set(["function_handle", "sentinel", "separator", "matlabroot"])

            @test isequal(vars_write["sin"], vars["sin"])
            @test isequal(vars_write["anonymous"], vars["anonymous"])
        end
    end
end

@testset "char arrays julia" begin
    m = Dict(
        "ascii_vector_chars" => ['A', 'B', 'C', 'D'],
        "ascii_matrix_chars" => reshape(['A', 'B', 'C', 'D'], 2, 2),
        "ascii_3d_chars" => reshape(['A','B','C','D','E','F','G','H'], 2, 2, 2),
        "unicode_vector_chars" => ['é', 'ñ', 'ø', 'ß'],
        "unicode_matrix_chars" => reshape(['é', 'ø', 'ñ', 'ß'], 2, 2),
        "unicode_3d_chars" => reshape(['é','ñ','ø','ß','å','ç','ü','î'], 2, 2, 2),
        "emoji_vector_chars" => ['😀','🚀','🎉','🐍'],
        "emoji_matrix_chars" => reshape(['😀','🚀', '🎉','🐍'], 2, 2),
        "emoji_3d_chars" => reshape(['😀','🎉','🚀','🐍','🧠','📦','🌍','🔥'], 2, 2, 2),
        "mixed_chars" => reshape(['A'; '😀'], 2, 1),
    )

    m_actual = Dict(
        "ascii_vector_chars"   => ["A", "B", "C", "D"],
        "ascii_matrix_chars"   => ["AC", "BD"],
        "ascii_3d_chars"       => ["AC" "EG"; "BD" "FH"],
        "unicode_vector_chars" => ["é", "ñ", "ø", "ß"],
        "unicode_matrix_chars" => ["éñ", "øß"],
        "unicode_3d_chars"     => ["éø" "åü"; "ñß" "çî"],
        "emoji_vector_chars"   => ["😀", "🚀", "🎉", "🐍"],
        "emoji_matrix_chars"   => ["😀🎉", "🚀🐍"],
        "emoji_3d_chars"       => ["😀🚀" "🧠🌍"; "🎉🐍" "📦🔥"],
        "mixed_chars"          => ["A ", "😀"],
    )

    mktempdir() do tmpdir
        tmpfile = joinpath(tmpdir, "test.mat")
        matwrite(tmpfile, m)
        vars_write = matread(tmpfile)
        for key in keys(m_actual)
            @test haskey(vars_write, key)
            @test vars_write[key] == m_actual[key]
        end
    end
end

# MAT_v5.jl
# Tools for reading MATLAB v5 files in Julia
#
# Copyright (C) 2012   Simon Kornblith
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# MATLAB's file format documentation can be found at
# http://www.mathworks.com/help/pdf_doc/matlab/matfile_format.pdf

module MAT_v5
using CodecZlib, HDF5, SparseArrays
import Base: read, write, close
import ..MAT_types: MatlabStructArray, MatlabClassObject, MatlabTable, FunctionHandle, decode_char_array

using ..MAT_subsys

round_uint8(data) = round.(UInt8, data)
complex_array(a, b) = complex.(a, b)

mutable struct Matlabv5File <: HDF5.H5DataStore
    ios::IOStream
    swap_bytes::Bool
    subsystem::Subsystem
    subsystem_position::UInt64 # nr of bytes taken by subsystem
    varnames::Dict{String, Int64}

    Matlabv5File(ios, swap_bytes) = new(ios, swap_bytes, Subsystem(), UInt64(0))
end

function Base.show(io::IO, f::Matlabv5File)
    print(io, "Matlabv5File(")
    print(io, f.ios, ", ")
    print(io, f.swap_bytes, ")")
end

const miINT8 = 1
const miUINT8 = 2
const miINT16 = 3
const miUINT16 = 4
const miINT32 = 5
const miUINT32 = 6
const miSINGLE = 7
const miDOUBLE = 9
const miINT64 = 12
const miUINT64 = 13
const miMATRIX = 14
const miCOMPRESSED = 15
const miUTF8 = 16
const miUTF16 = 17
const miUTF32 = 18
const mxCELL_CLASS = 1
const mxSTRUCT_CLASS = 2
const mxOBJECT_CLASS = 3
const mxCHAR_CLASS = 4
const mxSPARSE_CLASS = 5
const mxDOUBLE_CLASS = 6
const mxSINGLE_CLASS = 7
const mxINT8_CLASS = 8
const mxUINT8_CLASS = 9
const mxINT16_CLASS = 10
const mxUINT16_CLASS = 11
const mxINT32_CLASS = 12
const mxUINT32_CLASS = 13
const mxINT64_CLASS = 14
const mxUINT64_CLASS = 15
const mxFUNCTION_CLASS = 16
const mxOPAQUE_CLASS = 17
const READ_TYPES = Type[
    Int8, UInt8, Int16, UInt16, Int32, UInt32, Float32, Union{},
    Float64, Union{}, Union{}, Int64, UInt64]
const CONVERT_TYPES = Type[
    Union{}, Union{}, Union{}, Union{},
    Union{}, Float64, Float32, Int8, UInt8,
    Int16, UInt16, Int32, UInt32, Int64, UInt64]

read_bswap(f::IO, swap_bytes::Bool, ::Type{T}) where T =
    swap_bytes ? bswap(read(f, T)) : read(f, T)
function read_bswap(f::IO, swap_bytes::Bool, ::Type{T}, dim::Union{Int, Tuple{Vararg{Int}}}) where T
    d = read!(f, Array{T}(undef, dim))
    if swap_bytes
        for i = 1:length(d)
            @inbounds d[i] = bswap(d[i])
        end
    end
    d
end
function read_bswap(f::IO, swap_bytes::Bool, d::AbstractArray{T}) where T
    readbytes!(f, reinterpret(UInt8, d))
    if swap_bytes
        for i = 1:length(d)
            @inbounds d[i] = bswap(d[i])
        end
    end
    d
end

skip_padding(f::IO, nbytes::Int, hbytes::Int) = if nbytes % hbytes != 0
    skip(f, hbytes-(nbytes % hbytes))
end

# Read data type and number of bytes at the start of a data element
function read_header(f::IO, swap_bytes::Bool)
    dtype = read_bswap(f, swap_bytes, UInt32)

    if (dtype & 0xFFFF0000) != 0
        # Small Data Element Format
        (dtype & 0x0000FFFF, convert(Int, dtype >> 16), 4)
    else
        # Data Element Format
        (dtype, convert(Int, read_bswap(f, swap_bytes, UInt32)), 8)
    end
end

# Read data element as a vector of a given type
function read_element(f::IO, swap_bytes::Bool, ::Type{T}) where T
    (dtype, nbytes, hbytes) = read_header(f, swap_bytes)
    data = read_bswap(f, swap_bytes, T, Int(div(nbytes, sizeof(T))))
    skip_padding(f, nbytes, hbytes)
    data
end

# Read data element as encoded type
function read_data(f::IO, swap_bytes::Bool)
    (dtype, nbytes, hbytes) = read_header(f, swap_bytes)
    read_type = READ_TYPES[dtype]
    data = read_bswap(f, swap_bytes, read_type, Int(div(nbytes, sizeof(read_type))))
    skip_padding(f, nbytes, hbytes)
    data
end

# Read data element as encoded type with given dimensions, converting
# to another type if necessary and collapsing one-element matrices to
# scalars
function read_data(f::IO, swap_bytes::Bool, ::Type{T}, dimensions::Vector{Int32}) where T
    (dtype, nbytes, hbytes) = read_header(f, swap_bytes)
    read_type = READ_TYPES[dtype]
    if (read_type === UInt8) && (T === Bool)
        read_type = Bool
    end

    read_array = any(dimensions .!= 1)
    if sizeof(read_type)*prod(dimensions) != nbytes
        error("Invalid element length")
    end
    if read_array
        data = read_bswap(f, swap_bytes, read_type, tuple(convert(Vector{Int}, dimensions)...))
    else
        data = read_bswap(f, swap_bytes, read_type)
    end
    skip_padding(f, nbytes, hbytes)

    read_array ? convert(Array{T}, data) : convert(T, data)
end

function read_cell(f::IO, swap_bytes::Bool, dimensions::Vector{Int32}, subsys::Subsystem)
    data = Array{Any}(undef, convert(Vector{Int}, dimensions)...)
    for i = 1:length(data)
        (ignored_name, data[i]) = read_matrix(f, swap_bytes, subsys)
    end
    data
end

function read_struct(f::IO, swap_bytes::Bool, dimensions::Vector{Int32}, is_object::Bool, subsys::Subsystem)
    if is_object
        class = String(read_element(f, swap_bytes, UInt8))
    else
        class = ""
    end
    field_length = read_element(f, swap_bytes, Int32)[1]
    field_names = read_element(f, swap_bytes, UInt8)
    n_fields = div(length(field_names), field_length)

    # Get field names as strings
    field_name_strings = Vector{String}(undef, n_fields)
    n_el = prod(dimensions)
    for i = 1:n_fields
        sname = field_names[(i-1)*field_length+1:i*field_length]
        index = something(findfirst(iszero, sname), 0)
        field_name_strings[i] = String(index == 0 ? sname : sname[1:index-1])
    end

    local data
    if n_el == 1
        # Read a single struct into a dict
        data = Dict{String, Any}()
        sizehint!(data, n_fields+1)
        for field_name in field_name_strings
            data[field_name] = read_matrix(f, swap_bytes, subsys)[2]
        end
        if is_object
            data = MatlabClassObject(data, class)
        end
    else
        # Read empty or multiple structs
        nfields = length(field_name_strings)
        N = length(dimensions)
        field_values = Array{Any, N}[Array{Any}(undef, dimensions...) for _ in 1:nfields]
        for i = 1:n_el
            for field in 1:nfields
                field_values[field][i] = read_matrix(f, swap_bytes, subsys)[2]
            end
        end
        data = MatlabStructArray{N}(field_name_strings, field_values, class)
    end

    data
end

function plusone!(A)
    for i = 1:length(A)
        @inbounds A[i] += 1
    end
    A
end

function read_sparse(f::IO, swap_bytes::Bool, dimensions::Vector{Int32}, flags::Vector{UInt32})
    local m::Int, n::Int
    if length(dimensions) == 2
        (m, n) = dimensions
    elseif length(dimensions) == 1
        m = dimensions[1]
        n = 1
    elseif length(dimensions) == 0
        m = 0
        n = 0
    else
        error("invalid dimensions encountered for sparse array")
    end

    m = isempty(dimensions) ? 0 : dimensions[1]
    n = length(dimensions) <= 1 ? 0 : dimensions[2]
    ir = plusone!(convert(Vector{Int}, read_element(f, swap_bytes, Int32)))
    jc = plusone!(convert(Vector{Int}, read_element(f, swap_bytes, Int32)))
    if (flags[1] & (1 << 9)) != 0 # logical
        # WTF. For some reason logical sparse matrices are tagged as doubles.
        pr = read_element(f, swap_bytes, Bool)
    else
        pr = read_data(f, swap_bytes)
        if (flags[1] & (1 << 11)) != 0 # complex
            pr = complex_array(pr, read_data(f, swap_bytes))
        end
    end
    if length(ir) > length(pr)
        # Fix for Issue #169, xref https://github.com/JuliaLang/julia/pull/40523
        #=
        # The following expression must be obeyed according to
        # https://github.com/JuliaLang/julia/blob/b3e4341d43da32f4ab6087230d98d00b89c8c004/stdlib/SparseArrays/src/sparsematrix.jl#L86-L90
        @debug "SparseMatrixCSC" m n jc ir pr
        @debug "SparseMatrixCSC check " length(jc) n+1 jc[end]-1 length(ir) length(pr) begin
            length(jc) == n + 1 && jc[end] - 1 == length(ir) == length(pr)
        end
        =#
        # Truncate rowvals (ir) to the be the same length as the non-zero elements (pr)
        resize!(ir, length(pr))
    end
    SparseMatrixCSC(m, n, jc, ir, pr)
end

truncate_to_uint8(x) = x % UInt8

function read_string(f::IO, swap_bytes::Bool, dimensions::Vector{Int32})
    (dtype, nbytes, hbytes) = read_header(f, swap_bytes)
    codec =
        if dtype in (miUINT8, miUINT16, miUTF8)
            codec = :utf8
        elseif dtype == miUTF16
            codec = :utf16
        elseif dtype == miUTF32
            codec = :utf32
        else
            error("Unsupported char codec")
        end

    if dtype <= 2 || dtype == 16
        raw = read!(f, Vector{UInt8}(undef, nbytes))
    elseif dtype <= 4 || dtype == 17
        raw = read_bswap(f, swap_bytes, UInt16, div(nbytes,2))
    elseif dtype == 18
        raw = read_bswap(f, swap_bytes, UInt32, div(nbytes,4))
    end

    arr = reshape(raw, Tuple(dimensions))
    data = decode_char_array(arr, codec)
    skip_padding(f, nbytes, hbytes)
    data
end

function read_function_handle(f::IO, swap_bytes::Bool, subsys::Subsystem)
    data = read_matrix(f, swap_bytes, subsys)[2] # read_matrix returns (var_name, data)
    return FunctionHandle(data)
end

function read_opaque(f::IO, swap_bytes::Bool, subsys::Subsystem)
    type_name = String(read_element(f, swap_bytes, UInt8))
    classname = String(read_element(f, swap_bytes, UInt8))

    if classname == "FileWrapper__"
        return read_matrix(f, swap_bytes, subsys)
    end

    _, metadata = read_matrix(f, swap_bytes, subsys)
    return MAT_subsys.load_mcos_object(metadata, type_name, subsys)
end

# Read matrix data
function read_matrix(f::IO, swap_bytes::Bool, subsys::Subsystem)
    (dtype, nbytes) = read_header(f, swap_bytes)
    if dtype == miCOMPRESSED
        decompressed_ios = ZlibDecompressorStream(IOBuffer(read!(f, Vector{UInt8}(undef, nbytes))))
        return read_matrix(decompressed_ios, swap_bytes, subsys)
    elseif dtype != miMATRIX
        error("Unexpected data type")
    elseif nbytes == 0
        # If one creates a cell array using
        #     y = cell(m, n)
        # then MATLAB will save the empty cells as zero-byte matrices. If one creates a
        # empty cells using
        #     a = {[], [], []}
        # then MATLAB does not save the empty cells as zero-byte matrices. To avoid
        # surprises, we produce an empty array in both cases.
        return ("", Matrix{Union{}}(undef, 0, 0))
    end

    flags = read_element(f, swap_bytes, UInt32)
    class = flags[1] & 0xFF

    if class != mxOPAQUE_CLASS
        dimensions = read_element(f, swap_bytes, Int32)
    end

    name = String(read_element(f, swap_bytes, UInt8))

    local data
    if class == mxCELL_CLASS
        data = read_cell(f, swap_bytes, dimensions, subsys)
    elseif class == mxSTRUCT_CLASS || class == mxOBJECT_CLASS
        data = read_struct(f, swap_bytes, dimensions, class == mxOBJECT_CLASS, subsys)
    elseif class == mxSPARSE_CLASS
        data = read_sparse(f, swap_bytes, dimensions, flags)
    elseif class == mxCHAR_CLASS
        data = read_string(f, swap_bytes, dimensions)
    elseif class == mxFUNCTION_CLASS
        data = read_function_handle(f, swap_bytes, subsys)
    elseif class == mxOPAQUE_CLASS
        data = read_opaque(f, swap_bytes, subsys)
    else
        if (flags[1] & (1 << 9)) != 0 # logical
            data = read_data(f, swap_bytes, Bool, dimensions)
        else
            convert_type = CONVERT_TYPES[class]
            data = read_data(f, swap_bytes, convert_type, dimensions)
            if (flags[1] & (1 << 11)) != 0 # complex
                data = complex_array(data, read_data(f, swap_bytes, convert_type, dimensions))
            end
        end
    end

    return (name, data)
end

# Open MAT file for reading
function matopen(ios::IOStream, endian_indicator::UInt16; table::Type=MatlabTable, convert_opaque::Bool=true)
    matfile = Matlabv5File(ios, endian_indicator == 0x494D)

    seek(matfile.ios, 116)
    subsys_offset = read_bswap(matfile.ios, matfile.swap_bytes, UInt64)
    if subsys_offset == 0x2020202020202020
        subsys_offset = UInt64(0)
    end
    if subsys_offset != 0
        matfile.subsystem_position = subsys_offset
        matfile.subsystem.table_type = table
        matfile.subsystem.convert_opaque = convert_opaque
        read_subsystem!(matfile)
    end

    return matfile
end

# Read whole MAT file
function read(matfile::Matlabv5File)
    vars = Dict{String, Any}()
    seek(matfile.ios, 128)
    while !eof(matfile.ios)
        pos = position(matfile.ios)
        if pos == matfile.subsystem_position
            # Skip reading subsystem again
            (_, nbytes) = read_header(matfile.ios, matfile.swap_bytes)
            skip(matfile.ios, nbytes)
            continue
        end
        (name, data) = read_matrix(matfile.ios, matfile.swap_bytes, matfile.subsystem)
        vars[name] = data
    end
    vars
end

function read_subsystem!(matfile::Matlabv5File)
    ios = matfile.ios
    swap_bytes = matfile.swap_bytes
    seek(ios, matfile.subsystem_position)
    (_, subsystem_data) = read_matrix(ios, swap_bytes, matfile.subsystem)
    buf = IOBuffer(vec(subsystem_data))
    seek(buf, 8) # Skip subsystem header
    _, subsys_data = read_matrix(buf, swap_bytes, matfile.subsystem)
    MAT_subsys.load_subsys!(matfile.subsystem, subsys_data, swap_bytes)
end

# Read only variable names from an HDF5 file
function getvarnames(matfile::Matlabv5File)
    if !isdefined(matfile, :varnames)
        seek(matfile.ios, 128)
        matfile.varnames = varnames = Dict{String, Int64}()
        while !eof(matfile.ios)
            offset = position(matfile.ios)
            (dtype, nbytes, hbytes) = read_header(matfile.ios, matfile.swap_bytes)
            if dtype == miCOMPRESSED
                f = ZlibDecompressorStream(matfile.ios)
                read_header(f, matfile.swap_bytes)
            elseif dtype == miMATRIX
                f = matfile.ios
            else
                error("Unexpected data type")
            end

            flags = read_element(f, matfile.swap_bytes, UInt32)
            class = flags[1] & 0xFF
            if class != mxOPAQUE_CLASS
                read_element(f, matfile.swap_bytes, Int32)
            end

            varname = String(read_element(f, matfile.swap_bytes, UInt8))
            if varname == ""
                # Skip unnamed variable (subsystem)
                seek(matfile.ios, offset+nbytes+hbytes)
                continue
            end

            varnames[varname] = offset
            seek(matfile.ios, offset+nbytes+hbytes)
        end
    end
    matfile.varnames
end

Base.haskey(matfile::Matlabv5File, varname::String) =
    haskey(getvarnames(matfile), varname)
Base.keys(matfile::Matlabv5File) =
    keys(getvarnames(matfile))

# Read a variable from a MAT file
function read(matfile::Matlabv5File, varname::String)
    varnames = getvarnames(matfile)
    if !haskey(varnames, varname)
        error("no variable $varname in file")
    end
    seek(matfile.ios, varnames[varname])
    (name, data) = read_matrix(matfile.ios, matfile.swap_bytes, matfile.subsystem)
    data
end

# Complain about writing to a MAT file
function write(parent::Matlabv5File, name::String, s)
    error("Writing to a MATLAB v5 file is not currently supported. Create a new file instead.")
end

# Close MAT file
close(matfile::Matlabv5File) = close(matfile.ios)
end

# MAT_types.jl
# Internal types used by MAT.jl
#
# Copyright (C) 2012   Matthijs Cox
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

###########################################
## Reading and writing MATLAB .mat files ##
###########################################

module MAT_types

using StringEncodings: StringEncodings
import StringEncodings: Encoding
import Dates
import Dates: DateTime, Second, Millisecond
import PooledArrays: PooledArray, RefArray
using Tables: Tables
import OrderedCollections: OrderedDict

export MatlabStructArray, StructArrayField, convert_struct_array
export MatlabClassObject
export MatlabOpaque, convert_opaque
export MatlabTable
export ScalarOrArray
export FunctionHandle

const ScalarOrArray{T} = Union{T, AbstractArray{T}}

# struct arrays are stored as columns per field name
"""
    MatlabStructArray{N}(
        names::Vector{String},
        values::Vector{Array{Any,N}},
        class::String = "",
    )

Data structure to store matlab struct arrays, which stores the field names separate from the field values.
The field values are stored as columns of `Array{Any,N}` per Matlab field, which is how MAT files store these structures.

These are distinct from cell arrays of structs,
which are handled as in MAT.jl as `Array{Any,N}` with `Dict{String,Any}` inside,
for example `Any[Dict("x"=>1), Dict("x"=>2)]`.

Old class object arrays can be handled by providing a non-empty class name.

# Example

```julia
using MAT

s_arr = MatlabStructArray(["a", "b"], [[1, 2],["foo", 5]])

# write-read
matwrite("matfile.mat", Dict{String,Any}("struct_array" => s_arr))
read_s_arr = matread("matfile.mat")["struct_array"]

# convert to Dict Array
dict_array = Array{Dict{String,Any}}(s_arr)

# convert to Dict (with arrays as fields)
dict = Dict{String,Any}(s_arr)
```
"""
struct MatlabStructArray{N}
    names::Vector{String}
    values::Vector{Array{Any,N}}
    class::String
    function MatlabStructArray(
        names::Vector{String},
        values::Vector{Array{Any,N}},
        class::String="";
        check::Bool=true,
    ) where {N}
        check && check_struct_array(names, values)
        return new{N}(names, values, class)
    end
    function MatlabStructArray{N}(
        names::Vector{String}, values::Vector{Array{Any,N}}, class::String=""
    ) where {N}
        return new{N}(names, values, class)
    end
end

function check_struct_array(names::Vector{String}, values::Vector{Array{Any,N}}) where {N}
    if length(names) != length(values)
        error("MatlabStructArray requires equal number of names and values")
    end
    first_value, rest_values = Iterators.peel(values)
    first_len = length(first_value)
    if !all(x -> length(x) == first_len, rest_values)
        error("MatlabStructArray requires all value columns to be of equal length")
    end
end

function MatlabStructArray(
    names::AbstractVector{<:AbstractString},
    values::AbstractArray{A},
    class="";
    check::Bool=true,
) where {N,A<:AbstractArray{T,N} where {T}}
    return MatlabStructArray(
        string.(names), Vector{Array{Any,N}}(values), string(class); check=check
    )
end
function MatlabStructArray(
    names::Vector{String}, values::AbstractArray{A}, class=""; check::Bool=true
) where {N,A<:AbstractArray{T,N} where {T}}
    return MatlabStructArray(
        names, Vector{Array{Any,N}}(values), string(class); check=check
    )
end

# empty array
function MatlabStructArray(names::AbstractVector{<:AbstractString}, dims::Tuple)
    N = length(dims)
    return MatlabStructArray{N}(names, [Array{Any,N}(undef, dims...) for n in names])
end
function MatlabStructArray(names::AbstractVector{<:AbstractString})
    return MatlabStructArray(names, (0, 0))
end

Base.eltype(::Type{MatlabStructArray{N}}) where {N} = Pair{String,Array{Any,N}}
Base.length(arr::MatlabStructArray) = length(arr.names)
Base.keys(arr::MatlabStructArray) = arr.names
Base.values(arr::MatlabStructArray) = arr.values
Base.haskey(arr::MatlabStructArray, k::AbstractString) = k in keys(arr)
function Base.copy(arr::MatlabStructArray{N}) where {N}
    return MatlabStructArray{N}(copy(arr.names), copy(arr.values))
end
class(arr::MatlabStructArray) = arr.class
class(d::AbstractDict) = ""

function Base.iterate(arr::T, i=next_state(arr)) where {T<:MatlabStructArray}
    if i == 0
        return nothing
    else
        return (eltype(T)(arr.names[i], arr.values[i]), next_state(arr, i))
    end
end
next_state(arr, i=0) = length(arr) == i ? 0 : i + 1

function Base.show(io::IO, ::MIME"text/plain", arr::MatlabStructArray)
    summary(io, arr)
    ncol = length(arr.values)
    print(io, " with $(ncol) ")
    col_word = ncol == 1 ? "column" : "columns"
    print(io, col_word, ":")
    for (k, v) in arr
        print(io, "\n \"$k\": ")
        summary(io, v)
    end
end

function Base.:(==)(m1::MatlabStructArray{N}, m2::MatlabStructArray{N}) where {N}
    return isequal(m1.names, m2.names) &&
           isequal(m1.values, m2.values) &&
           isequal(m1.class, m2.class)
end

function Base.isapprox(m1::MatlabStructArray, m2::MatlabStructArray; kwargs...)
    return isequal(m1.class, m2.class) && issetequal(m1.names, m2.names) &&
    key_based_isapprox(m1.names, m1, m2; kwargs...)
end

function find_index(m::MatlabStructArray, s::AbstractString)
    idx = findfirst(isequal(s), m.names)
    if isnothing(idx)
        error("field \"$s\" not found in MatlabStructArray")
    end
    return idx
end

function Base.getindex(m::MatlabStructArray, s::AbstractString)
    idx = find_index(m, s)
    return getindex(m.values, idx)
end

function Base.setindex!(m::MatlabStructArray{N1}, input::AbstractArray{T,N2}, s::AbstractString) where {N1,N2,T}
    error("size of input is not equal to MatlabStructArray column size")
end

function Base.setindex!(m::MatlabStructArray{N}, input::AbstractArray{T,N}, s::AbstractString) where {N,T}
    idx = find_index(m, s)
    v = Array{Any,N}(input)
    if size(v) != size(m.values[idx])
        error("size of input is not equal to MatlabStructArray column size")
    end
    return setindex!(m.values, v, idx)
end

function Base.get(m::MatlabStructArray, s::AbstractString, default)
    idx = findfirst(isequal(s), m.names)
    if isnothing(idx)
        return default
    else
        return getindex(m.values, idx)
    end
end

# convert Dict array to MatlabStructArray
function MatlabStructArray(arr::AbstractArray{<:AbstractDict,N}, class::String="") where {N}
    first_dict, remaining_dicts = Iterators.peel(arr)
    first_keys = keys(first_dict)
    field_names = string.(first_keys)
    # Ensure same field set for all elements
    for d in remaining_dicts
        if !issetequal(keys(d), first_keys)
            error(
                "Cannot convert Dict array to MatlabStructArray. All elements must share identical field names",
            )
        end
    end
    field_values = Vector{Array{Any,N}}(undef, length(field_names))
    for (idx, k) in enumerate(first_keys)
        this_field_values = Array{Any,N}(undef, size(arr))
        for (idx, d) in enumerate(arr)
            this_field_values[idx] = d[k]
        end
        field_values[idx] = this_field_values
    end
    return MatlabStructArray{N}(field_names, field_values, class)
end

function Base.Dict(arr::MatlabStructArray)
    return Base.Dict{String,Any}(arr)
end
function Base.Dict{String,Any}(arr::MatlabStructArray)
    return Base.Dict{String,Any}(arr.names .=> arr.values)
end

Base.Array{D}(arr::MatlabStructArray{N}) where {D<:AbstractDict,N} = Array{D,N}(arr)

function Base.Array{D,N}(arr::MatlabStructArray{N}) where {D<:AbstractDict,N}
    first_field = first(arr.values)
    sz = size(first_field)
    result = Array{D,N}(undef, sz)
    for idx in eachindex(first_field)
        element_values = (v[idx] for v in arr.values)
        result[idx] = create_struct(D, arr.names, element_values, arr.class)
    end
    return result
end

function Base.getindex(arr::MatlabStructArray, s::Integer)
    row_values = [getindex(v, s) for v in arr.values]
    if isempty(arr.class)
        D = Dict{String,Any}
    else
        D = OrderedDict{String,Any}
    end
    return create_struct(D, arr.names, row_values, arr.class)
end

function create_struct(::Type{D}, keys, values, class::String) where {T,D<:AbstractDict{T}}
    return D(T.(keys) .=> values)
end

# 1D MatlabStructArray also counts as table (mostly for testing purposes)
Tables.istable(::Type{MatlabStructArray{1}}) = true
Tables.columns(t::MatlabStructArray{1}) = Symbol.(t.values)
Tables.columnnames(t::MatlabStructArray{1}) = t.names
Tables.getcolumn(t::MatlabStructArray{1}, nm::String) = t[nm]
Tables.getcolumn(t::MatlabStructArray{1}, nm::Symbol) = Tables.getcolumn(t, string(nm))
function MatlabStructArray{1}(t::Tables.CopiedColumns)
    col_names = Tables.columnnames(t)
    return MatlabStructArray{1}(
        string.(col_names), [Vector{Any}(Tables.getcolumn(t, nm)) for nm in col_names]
    )
end
MatlabStructArray(t::Tables.CopiedColumns) = MatlabStructArray{1}(t)

struct StructArrayField{N}
    values::Array{Any,N}
end
dimension(::StructArrayField{N}) where {N} = N

"""
Internal Marker for Empty Structs with dimensions like 1x0 or 0x0
"""
struct EmptyStruct
    dims::Vector{UInt64}
end
class(m::EmptyStruct) = ""

"""
    FunctionHandle(d::Dict{String, Any}) <: AbstractDict{String, Any}

Type to store function handles which are stored as structs in MATLAB.
"""
struct FunctionHandle{D<:AbstractDict{String,Any}} <: AbstractDict{String,Any}
    d::D
end

Base.eltype(::Type{FunctionHandle}) = Pair{String,Any}
Base.length(m::FunctionHandle) = length(m.d)
Base.keys(m::FunctionHandle) = keys(m.d)
Base.values(m::FunctionHandle) = values(m.d)
Base.getindex(m::FunctionHandle, i) = getindex(m.d, i)
Base.setindex!(m::FunctionHandle, v, k) = setindex!(m.d, v, k)
Base.iterate(m::FunctionHandle, i) = iterate(m.d, i)
Base.iterate(m::FunctionHandle) = iterate(m.d)
Base.haskey(m::FunctionHandle, k) = haskey(m.d, k)
Base.get(m::FunctionHandle, k, default) = get(m.d, k, default)

function Base.:(==)(m1::FunctionHandle, m2::FunctionHandle)
    return m1.d == m2.d
end

function Base.isapprox(m1::FunctionHandle, m2::FunctionHandle; kwargs...)
    return dict_isapprox(m1.d, m2.d; kwargs...)
end

"""
    MatlabClassObject(
        d::Dict{String, Any},
        class::String,
    ) <: AbstractDict{String, Any}

Type to store old class objects. Inside MATLAB a class named \"TestClassOld\" would be defined within `@TestClassOld` folders.

If you want to write these objects you have to make sure the keys in the Dict match the class defined properties/fields.
"""
struct MatlabClassObject{D<:AbstractDict{String,Any}} <: AbstractDict{String,Any}
    d::D
    class::String
end

class(m::MatlabClassObject) = m.class

Base.eltype(::Type{MatlabClassObject}) = Pair{String,Any}
Base.length(m::MatlabClassObject) = length(m.d)
Base.keys(m::MatlabClassObject) = keys(m.d)
Base.values(m::MatlabClassObject) = values(m.d)
Base.getindex(m::MatlabClassObject, i) = getindex(m.d, i)
Base.setindex!(m::MatlabClassObject, v, k) = setindex!(m.d, v, k)
Base.iterate(m::MatlabClassObject, i) = iterate(m.d, i)
Base.iterate(m::MatlabClassObject) = iterate(m.d)
Base.haskey(m::MatlabClassObject, k) = haskey(m.d, k)
Base.get(m::MatlabClassObject, k, default) = get(m.d, k, default)

function Base.:(==)(m1::MatlabClassObject, m2::MatlabClassObject)
    return m1.class == m2.class && m1.d == m2.d
end

function Base.isapprox(m1::MatlabClassObject, m2::MatlabClassObject; kwargs...)
    return m1.class == m2.class && dict_isapprox(m1.d, m2.d; kwargs...)
end

function MatlabStructArray(arr::AbstractArray{<:MatlabClassObject})
    first_obj, remaining_obj = Iterators.peel(arr)
    class = first_obj.class
    if !all(x -> isequal(class, x.class), remaining_obj)
        error(
            "to write a MatlabClassObject array all classes must be equal. Use `Array{Any}` to write a cell array",
        )
    end
    return MatlabStructArray(arr, class)
end

function convert_struct_array(d::AbstractDict{String,Any}, class::String="")
    # there is no possibility of having cell arrays mixed with struct arrays (afaik)
    field_values = first(values(d))
    if field_values isa StructArrayField
        return MatlabStructArray{dimension(field_values)}(
            collect(keys(d)), [arr.values for arr in values(d)], class
        )
    else
        if isempty(class)
            return d
        elseif class == "function_handle"
            return FunctionHandle(d)
        else
            return MatlabClassObject(d, class)
        end
    end
end

function Base.Array(arr::MatlabStructArray{N}) where {N}
    if isempty(arr.class)
        return Array{Dict{String,Any},N}(arr)
    else
        # ordered dict by default, to preserve field order
        D = OrderedDict{String,Any}
        return Array{MatlabClassObject{D},N}(arr)
    end
end

function create_struct(::Type{MatlabClassObject{D}}, keys, values, class::String) where {D<:AbstractDict}
    d = D(string.(keys) .=> values)
    return MatlabClassObject{D}(d, class)
end

"""
    MatlabOpaque(
        d::Dict{String, Any},
        class::String,
    ) <: AbstractDict{String, Any}

Type to store opaque class objects.
These are the 'modern' Matlab classes, different from the old `MatlabClassObject` types.

"""
struct MatlabOpaque{D<:AbstractDict{String,Any}} <: AbstractDict{String,Any}
    d::D
    class::String
end
class(m::MatlabOpaque) = m.class

Base.eltype(::Type{MatlabOpaque}) = Pair{String,Any}
Base.length(m::MatlabOpaque) = length(m.d)
Base.keys(m::MatlabOpaque) = keys(m.d)
Base.values(m::MatlabOpaque) = values(m.d)
Base.getindex(m::MatlabOpaque, i) = getindex(m.d, i)
Base.setindex!(m::MatlabOpaque, v, k) = setindex!(m.d, v, k)
Base.iterate(m::MatlabOpaque, i) = iterate(m.d, i)
Base.iterate(m::MatlabOpaque) = iterate(m.d)
Base.haskey(m::MatlabOpaque, k) = haskey(m.d, k)
Base.get(m::MatlabOpaque, k, default) = get(m.d, k, default)

function Base.:(==)(m1::MatlabOpaque, m2::MatlabOpaque)
    return m1.class == m2.class && m1.d == m2.d
end

function Base.isapprox(m1::MatlabOpaque, m2::MatlabOpaque; kwargs...)
    return m1.class == m2.class && dict_isapprox(m1.d, m2.d; kwargs...)
end

function dict_isapprox(d1::AbstractDict{T}, d2::AbstractDict{T}; kwargs...) where T
    issetequal(keys(d1), keys(d2)) || return false
    return key_based_isapprox(keys(d1), d1, d2; kwargs...)
end
dict_isapprox(d1::AbstractDict{T1}, d2::AbstractDict{T2}; kwargs...) where {T1,T2} = false

function key_based_isapprox(keys, collection1, collection2; kwargs...)
    for k in keys
        v1, v2 = collection1[k], collection2[k]
        value_isapprox(v1, v2; kwargs...) || return false
    end
    return true
end

value_isapprox(x1::AbstractString, x2::AbstractString; kwargs...) = isequal(x1, x2)
value_isapprox(x1, x2; kwargs...) = isapprox(x1, x2; kwargs...)
value_isapprox(d1::AbstractDict, d2::AbstractDict; kwargs...) = dict_isapprox(x1, x2; kwargs...)

function convert_opaque(obj::MatlabOpaque; table::Type=Nothing)
    if obj.class == "string"
        return from_string(obj)
    elseif obj.class == "datetime"
        return from_datetime(obj)
    elseif obj.class == "duration"
        return from_duration(obj)
    elseif obj.class == "categorical"
        return from_categorical(obj)
    elseif obj.class == "table"
        return from_table(obj, table)
    else
        return obj
    end
end

# for reference: https://github.com/foreverallama/matio/blob/main/matio/utils/converters/matstring.py
function from_string(obj::MatlabOpaque, encoding::Encoding=Encoding(Symbol("UTF-16LE")))
    data = obj["any"]
    if isnothing(data) || isempty(data)
        return String[]
    end
    if data[1, 1] != 1
        @warn "String saved from a different MAT-file version. Returning empty string"
        return ""
    end
    ndims = data[1, 2]
    shape = Int.(data[1, 3:(2 + ndims)])
    num_strings = prod(shape)
    char_counts = data[1, (3 + ndims):(2 + ndims + num_strings)]
    byte_data = data[1, (3 + ndims + num_strings):end]
    bytes = reinterpret(UInt8, byte_data)

    strings = String[]
    pos = 1

    for char_count in char_counts
        byte_length = char_count * 2  # UTF-16 encoding
        extracted_bytes = bytes[pos:(pos + byte_length - 1)]
        str = StringEncodings.decode(extracted_bytes, encoding)
        push!(strings, str)
        pos += byte_length
    end

    if num_strings == 1
        return first(strings)
    else
        return reshape(strings, shape...)
    end
end

function from_datetime(obj::MatlabOpaque)
    dat = obj["data"]
    if isnothing(dat) || isempty(dat)
        return DateTime[]
    end
    if haskey(obj, "tz") && !isempty(obj["tz"])
        tz = obj["tz"]
        @warn "no timezone conversion yet for datetime objects. timezone of \"$tz\" ignored"
    end
    #isdate = obj["isDateOnly"] # optional: convert to Date instead of DateTime?
    return map_or_not(ms_to_datetime, dat)
end

# is the complex part the submilliseconds?
ms_to_datetime(ms::Complex) = ms_to_datetime(real(ms))
function ms_to_datetime(ms::Real)
    s, ms_rem = fldmod(ms, 1_000)  # whole seconds and remainder milliseconds
    return DateTime(1970, 1, 1) + Second(s) + Millisecond(round(Int, ms_rem))
end

function to_matlab_data(d::DateTime)
    ms = Dates.value(d)

    # matlab counts w.r.t. 1970
    matlab_offset = Dates.value(DateTime(1970, 1, 1))

    # note: can be negative, that's fine
    matlab_ms = ms - matlab_offset
    return Complex(Float64(matlab_ms))
end

function MatlabOpaque(d::ScalarOrArray{DateTime})
    return MatlabOpaque(
        Dict{String,Any}(
            "tz"   => "",
            "data" => map_or_not(to_matlab_data, d),
            "fmt"  => "",
        ),
        "datetime"
    )
end

function from_duration(obj::MatlabOpaque)
    dat = obj["millis"]
    #fmt = obj["fmt"] # TODO: format, e.g. 'd' to Day
    if isnothing(dat) || isempty(dat)
        return Millisecond[]
    end
    return map_or_not(Millisecond, dat)
end

to_matlab_millis(d::Millisecond) = Float64(Dates.value(d))

function MatlabOpaque(d::ScalarOrArray{Millisecond})
    return MatlabOpaque(
        Dict{String,Any}(
            "millis" => map_or_not(to_matlab_millis, d),
        ),
        "duration"
    )
end

function from_categorical(obj::MatlabOpaque)
    category_names = obj["categoryNames"]
    codes = obj["codes"]
    pool = vec(Array{promoted_eltype(category_names)}(category_names))
    code_type = eltype(codes)
    pool_type = eltype(pool)
    invpool = Dict{pool_type,code_type}(pool .=> code_type.(1:length(pool)))
    RA = typeof(codes)
    N = ndims(codes)
    return PooledArray{pool_type,code_type,N,RA}(RefArray(codes), invpool, pool)
end

function promoted_eltype(v::AbstractArray{Any})
    isempty(v) && return T
    first_el, remaining = Iterators.peel(v)
    T_out = typeof(first_el)
    for el in remaining
        T_out = promote_type(T_out, typeof(el))
    end
    return T_out
end
promoted_eltype(::AbstractArray{T}) where {T} = T

map_or_not(f, dat::AbstractArray) = map(f, dat)
map_or_not(f, dat) = f(dat)

struct MatlabTable
    names::Vector{Symbol}
    columns::Vector
end
Tables.istable(::Type{MatlabTable}) = true
Tables.columns(t::MatlabTable) = t.columns
Tables.columnnames(t::MatlabTable) = t.names
Tables.getcolumn(t::MatlabTable, nm::Symbol) = t[nm]
function find_index(m::MatlabTable, s::Symbol)
    idx = findfirst(isequal(s), m.names)
    if isnothing(idx)
        error("column :$s not found in MatlabTable")
    end
    return idx
end
function Base.getindex(m::MatlabTable, s::Symbol)
    idx = find_index(m, s)
    return getindex(m.columns, idx)
end
Base.getindex(m::MatlabTable, s::AbstractString) = getindex(m, Symbol(s))
MatlabTable(t::Tables.CopiedColumns{MatlabTable}) = Tables.source(t)

function from_table(obj::MatlabOpaque, ::Type{T}=MatlabTable) where {T}
    names = vec(Symbol.(obj["varnames"]))
    cols = vec([try_vec(c) for c in obj["data"]])
    t = MatlabTable(names, cols)
    return T(Tables.CopiedColumns(t))
end
# option to not convert and get the MatlabOpaque as table
from_table(obj::MatlabOpaque, ::Type{Nothing}) = obj

try_vec(c::Vector) = c
try_vec(c) = [c]
function try_vec(c::AbstractArray)
    return (size(c, 2) == 1) ? vec(c) : c
end

# MATLAB char array storage types:
# - miUINT8: ASCII or UTF-8. Can be directly converted to String.
# - miUINT16: UTF-8 encoding packed in 16-bit values. Reinterpret as uint8 and remove 0x00 MSB bytes
# - miUTF8/16/32: UTF-8/16/32 encoding. Transcode to UTF-8 if needed, then convert to String
_decode_row(row::AbstractVector{UInt8},  codec)  = String(row)
_decode_row(row::AbstractVector{UInt32}, codec) = String(transcode(UInt8, row))
function _decode_row(row::AbstractVector{UInt16}, codec)
    if codec == :utf16
        return String(transcode(UInt8, row))
    end

    n = length(row)
    out = Vector{UInt8}(undef, 2n)
    j = 1

    @inbounds for x in row
        msb = UInt8(x >> 8)
        lsb = UInt8(x & 0xff)

        if msb == 0x00
            out[j] = lsb
            j += 1
        else
            out[j] = msb
            out[j+1] = lsb
            j += 2
        end
    end

    resize!(out, j - 1)
    return String(out)
end

function decode_char_array(arr::AbstractArray{T}, codec::Symbol) where T <: Union{UInt8, UInt16, UInt32}
    char_len = size(arr, 2)
    other_dims = (size(arr, 1), size(arr)[3:end]...)

    if char_len == 0
        return fill("", other_dims)
    end

    if ndims(arr) == 2 && size(arr, 1) == 1
        # Return as single string instead of 1-element array
        row = view(arr, 1, :)
        return _decode_row(row, codec)
    end

    out = Array{String}(undef, other_dims...)
    for I in CartesianIndices(out)
        idx = Tuple(I)
        row = view(arr, idx[1], :, idx[2:end]...)
        out[I] = _decode_row(row, codec)
    end

    return out
end

end

# MAT_subsys.jl
# Tools for processing MAT-file subsystem data in Julia
#
# Copyright (C) 2025    Nithin Lakshmisha
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# For reference
# https://github.com/foreverallama/matio/blob/main/docs/subsystem_data_format.md

module MAT_subsys

import ..MAT_types: MatlabStructArray, MatlabOpaque, convert_opaque, EmptyStruct

export Subsystem

const FWRAP_VERSION = 4
const MCOS_IDENTIFIER = 0xdd000000

const matlab_saveobj_ret_types = String[
    "string",
    "timetable",
    "function_handle_workspace"
]

# Warning message for unknown regions
const warn_msg = "Unknown metadata found in MCOS subsystem. Please raise an issue to the maintainers to help improve support."

mutable struct Subsystem
    load_object_cache::Dict{UInt32,MatlabOpaque}
    save_object_cache::IdDict{MatlabOpaque,UInt32}
    num_names::UInt32 # number of mcos_names
    mcos_names::Vector{String} # Class and Property Names
    class_id_metadata::Vector{UInt32}
    object_id_metadata::Vector{Vector{UInt32}}
    saveobj_prop_metadata::Vector{Vector{UInt32}}
    obj_prop_metadata::Vector{Vector{UInt32}}
    dynprop_metadata::Vector{UInt32}
    _u6_metadata::Vector{UInt32}
    _u7_metadata::Vector{UInt32}
    prop_vals_saved::Vector{Any}
    _c3::Any
    mcos_class_alias_metadata::Any
    prop_vals_defaults::Any
    handle_data::Any
    java_data::Any

    # automatic MatlabOpaque conversion
    convert_opaque::Bool
    table_type::Type

    # Counters for saving
    saveobj_counter::UInt32
    normalobj_counter::UInt32
    obj_id_counter::UInt32
    class_id_counter::UInt32

    function Subsystem()
        return new(
            Dict{UInt32,MatlabOpaque}(),
            IdDict{MatlabOpaque,UInt32}(),
            UInt32(0),
            String[],
            UInt32[],
            Vector{Vector{UInt32}}(),
            Vector{Vector{UInt32}}(),
            Vector{Vector{UInt32}}(),
            UInt32[],
            UInt32[],
            UInt32[],
            Any[],
            nothing,
            Int32[],
            nothing,
            nothing,
            nothing,
            true,
            Nothing,
            UInt32(0),
            UInt32(0),
            UInt32(0),
            UInt32(0),
        )
    end
end

function swapped_reinterpret(T::Type, A::AbstractArray{UInt8}, swap_bytes::Bool)
    return reinterpret(T, swap_bytes ? reverse(A) : A)
end
# integers are written as uint8 (with swap), interpret as uint32
function swapped_reinterpret(A::AbstractArray{UInt8}, swap_bytes::Bool)
    return swapped_reinterpret(UInt32, A, swap_bytes)
end

function init_save!(subsys::Subsystem)
    append!(subsys.class_id_metadata, UInt32[0, 0, 0, 0])
    append!(subsys.dynprop_metadata, UInt32[0, 0])
    append!(subsys.mcos_class_alias_metadata, Int32[0])

    # These are Vector{Vector{uint32}}
    # need mutable inner vectors to handle nested properties
    push!(subsys.object_id_metadata, UInt32[0, 0, 0, 0, 0, 0])
    push!(subsys.saveobj_prop_metadata, UInt32[0, 0])
    push!(subsys.obj_prop_metadata, UInt32[0, 0])

    subsys._c3 = Any[]
    subsys.prop_vals_defaults = Any[]

    return subsys
end

function load_subsys!(subsystem_data::Dict{String,Any}, swap_bytes::Bool)
    subsys = Subsystem()
    return load_subsys!(subsys, subsystem_data, swap_bytes)
end

# Class and Property Names are stored as list of null-terminated strings
function load_mcos_names!(subsys::Subsystem, fwrap_metadata::AbstractArray{UInt8})
    start = 41
    pos = start
    name_count = 0
    while name_count < subsys.num_names
        if fwrap_metadata[pos] == 0x00
            push!(subsys.mcos_names, String(fwrap_metadata[start:(pos - 1)]))
            name_count += 1
            start = pos + 1
            if name_count == subsys.num_names
                break
            end
        end
        pos += 1
    end
end

function load_mcos_regions!(
    subsys::Subsystem, fwrap_metadata::AbstractArray{UInt8}, swap_bytes::Bool
)
    region_offsets = swapped_reinterpret(fwrap_metadata[9:40], swap_bytes)

    subsys.class_id_metadata = swapped_reinterpret(
        get_region(fwrap_metadata, region_offsets, 1), swap_bytes
    )
    subsys.saveobj_prop_metadata = [swapped_reinterpret(
        get_region(fwrap_metadata, region_offsets, 2), swap_bytes
    )]
    subsys.object_id_metadata = [swapped_reinterpret(
        get_region(fwrap_metadata, region_offsets, 3), swap_bytes
    )]
    subsys.obj_prop_metadata = [swapped_reinterpret(
        get_region(fwrap_metadata, region_offsets, 4), swap_bytes
    )]
    subsys.dynprop_metadata = swapped_reinterpret(
        get_region(fwrap_metadata, region_offsets, 5), swap_bytes
    )

    if region_offsets[7] != 0
        subsys._u6_metadata = swapped_reinterpret(
            get_region(fwrap_metadata, region_offsets, 6), swap_bytes
        )
    end

    if region_offsets[8] != 0
        subsys._u7_metadata = swapped_reinterpret(
            get_region(fwrap_metadata, region_offsets, 7), swap_bytes
        )
    end
end

function check_unknown_regions(subsys::Subsystem)
    # Warn about unsupported regions
    # We don't know what they contain yet
    # Users can raise issues if they see this warning to help improve support

    if length(subsys._u6_metadata) > 0
        # This region is supposedly empty
        @warn warn_msg
    end

    if any(subsys._u7_metadata .!= 0)
        # This is an 8 byte region, all zeros
        @warn warn_msg
    end

    if subsys._c3 === nothing
        return
    else
        for i=1:length(subsys._c3)
            # This region is a cell array of empty structs
            if length(subsys._c3[i]) > 0
                @warn warn_msg
                break
            end
        end
    end
end

function get_region(
    fwrap_metadata::Vector{UInt8}, region_offsets::AbstractVector{UInt32}, region::Integer
)
    return fwrap_metadata[(region_offsets[region] + 1):region_offsets[region + 1]]
end

function load_subsys!(subsys::Subsystem, subsystem_data::Dict{String,Any}, swap_bytes::Bool)
    try
        subsys.handle_data = get(subsystem_data, "handle", nothing)
        subsys.java_data = get(subsystem_data, "java", nothing)
        mcos_data = get(subsystem_data, "MCOS", nothing)
        if mcos_data === nothing
            return nothing
        end

        if mcos_data isa Tuple
            # Backward compatibility with MAT_v5
            mcos_data = mcos_data[2]
        end
        fwrap_metadata::Vector{UInt8} = vec(mcos_data[1, 1])

        version = swapped_reinterpret(fwrap_metadata[1:4], swap_bytes)[1]
        if version <= 1 || version > FWRAP_VERSION
            error("Cannot read subsystem: Unsupported FileWrapper version: $version")
        end

        subsys.num_names = swapped_reinterpret(fwrap_metadata[5:8], swap_bytes)[1]
        load_mcos_names!(subsys, fwrap_metadata)

        load_mcos_regions!(subsys, fwrap_metadata, swap_bytes)

        if version == 2
            subsys.prop_vals_saved = mcos_data[3:(end - 1), 1]
        elseif version == 3
            subsys.prop_vals_saved = mcos_data[3:(end - 2), 1]
            subsys.mcos_class_alias_metadata = mcos_data[end - 1, 1]
        else
            subsys.prop_vals_saved = mcos_data[3:(end - 3), 1]
            subsys._c3 = mcos_data[end - 2, 1]
        end

        subsys.prop_vals_defaults = mcos_data[end, 1]
        check_unknown_regions(subsys)
        return subsys
    catch
        @warn "Failed to load MAT-file subsystem data. Opaque objects will be skipped. Error: $(catch_backtrace())"
        return subsys
    end
end

function get_classname(subsys::Subsystem, class_id::UInt32)
    namespace_idx = subsys.class_id_metadata[class_id * 4 + 1]
    classname_idx = subsys.class_id_metadata[class_id * 4 + 2]

    if subsys.class_id_metadata[class_id * 4 + 3] != 0 ||
       subsys.class_id_metadata[class_id * 4 + 4] != 0
       # Unknown metadata
       @warn warn_msg
    end

    namespace = if namespace_idx == 0
        ""
    else
        subsys.mcos_names[namespace_idx] * "."
    end

    classname = namespace * subsys.mcos_names[classname_idx]
    return classname
end

function get_object_metadata(subsys::Subsystem, object_id::UInt32)
    return subsys.object_id_metadata[1][(object_id * 6 + 1):(object_id * 6 + 6)]
end

update_nested_props!(prop_value, subsys::Subsystem) = prop_value

function update_nested_props!(
    prop_value::Union{AbstractDict,MatlabStructArray}, subsys::Subsystem
)
    # Handle nested objects in structs
    for (key, value) in prop_value
        prop_value[key] = update_nested_props!(value, subsys)
    end
    return prop_value
end

function update_nested_props!(prop_value::Array{Any}, subsys::Subsystem)
    # Handle nested objects in a Cell
    for i in eachindex(prop_value)
        prop_value[i] = update_nested_props!(prop_value[i], subsys)
    end
    return prop_value
end

function update_nested_props!(prop_value::Array{UInt32}, subsys::Subsystem)
    # Hacky way to find and update nested objects
    # Nested objects are stored as a uint32 Matrix with a unique signature
    # MATLAB probably uses some kind of placeholders to decode
    # But this should work here

    if first(prop_value) == MCOS_IDENTIFIER
        # MATLAB identifies any uint32 array with first value 0xdd000000 as an MCOS object
        return load_mcos_object(prop_value, "MCOS", subsys)
    else
        return prop_value
    end
end

function get_default_properties(subsys::Subsystem, class_id::UInt32)
    default_props = Dict{String,Any}(subsys.prop_vals_defaults[class_id + 1, 1])
    for (key, value) in default_props
        default_props[key] = update_nested_props!(value, subsys)
    end
    return default_props
end

function get_property_idxs(subsys::Subsystem, obj_type_id::UInt32, saveobj_ret_type::Bool)
    prop_field_idxs =
        saveobj_ret_type ? subsys.saveobj_prop_metadata[1] : subsys.obj_prop_metadata[1]
    nfields = 3
    offset = 1
    while obj_type_id > 0
        nprops = prop_field_idxs[offset]
        offset += 1 + (nfields * nprops)
        offset += (offset + 1) % 2  # Padding
        obj_type_id -= 1
    end
    nprops = prop_field_idxs[offset]
    offset += 1
    return prop_field_idxs[offset:(offset + nprops * nfields - 1)]
end

function get_saved_properties(
    subsys::Subsystem, obj_type_id::UInt32, saveobj_ret_type::Bool
)
    save_prop_map = Dict{String,Any}()
    prop_field_idxs = get_property_idxs(subsys, obj_type_id, saveobj_ret_type)
    nprops = length(prop_field_idxs) ÷ 3
    for i in 0:(nprops - 1)
        prop_name = subsys.mcos_names[prop_field_idxs[i * 3 + 1]]
        prop_type = prop_field_idxs[i * 3 + 2]
        if prop_type == 0
            prop_value = subsys.mcos_names[prop_field_idxs[i * 3 + 3]]
        elseif prop_type == 1
            prop_value = subsys.prop_vals_saved[prop_field_idxs[i * 3 + 3] + 1]
        elseif prop_type == 2
            prop_value = prop_field_idxs[i * 3 + 3]
        else
            @warn "Unknown property type ID: $prop_type for property $prop_name encountered during deserialization"
            prop_value = prop_field_idxs[i * 3 + 3]
        end
        save_prop_map[prop_name] = update_nested_props!(prop_value, subsys)
    end
    return save_prop_map
end

function get_dynamic_properties(subsys::Subsystem, dep_id::UInt32)

    if dep_id == UInt32(0)
        return Dict{String,Any}()
    end

    # dynprops metadata is stored in format
    # [(nprops, prop_obj_id_1, ..., prop_obj_id_n), ...] for each dep_id

    offset = 1
    while dep_id > 0
        nprops = subsys.dynprop_metadata[offset]
        offset += 1 + nprops
        offset += (offset + 1) % 2  # Padding
        dep_id -= 1
    end

    ndynprops = subsys.dynprop_metadata[offset]
    offset += 1
    dyn_prop_obj_ids = subsys.dynprop_metadata[offset:(offset + ndynprops - 1)]

    if length(dyn_prop_obj_ids) == 0
        return Dict{String,Any}()
    end
    dyn_prop_map = Dict{String,Any}()
    for (i, obj_id) in enumerate(dyn_prop_obj_ids)
        dyn_class_id = get_object_metadata(subsys, obj_id)[1]
        classname = get_classname(subsys, dyn_class_id)
        dynobj_props = Dict{String,Any}()
        dynobj = MatlabOpaque(dynobj_props, classname)
        merge!(dynobj_props, get_properties(subsys, obj_id))
        dyn_prop_map["__dynamic_property_$(i)__"] = dynobj
    end
    return dyn_prop_map
end

function get_properties(subsys::Subsystem, object_id::UInt32)
    if object_id == 0
        return Dict{String,Any}()
    end

    class_id, _x1, _x2, saveobj_id, normobj_id, dep_id = get_object_metadata(subsys, object_id)
    if _x1 != 0 || _x2 != 0
        # Unknown metadata
        @warn warn_msg
    end

    if saveobj_id != 0
        saveobj_ret_type = true
        obj_type_id = saveobj_id
    else
        saveobj_ret_type = false
        obj_type_id = normobj_id
    end

    defaults = get_default_properties(subsys, class_id)
    prop_map = merge(defaults, get_saved_properties(subsys, obj_type_id, saveobj_ret_type))
    dyn_props = get_dynamic_properties(subsys, dep_id)
    merge!(prop_map, dyn_props)
    return prop_map
end

function get_object!(subsys::Subsystem, oid::UInt32, classname::String)
    if haskey(subsys.load_object_cache, oid)
        # object is already cached, just retrieve it
        obj = subsys.load_object_cache[oid]
    else # it's a new object
        prop_dict = Dict{String,Any}()
        obj = MatlabOpaque(prop_dict, classname)
        # cache the new object
        subsys.load_object_cache[oid] = obj
        # caching must be done before a next call to `get_properties` to avoid any infinite recursion
        merge!(prop_dict, get_properties(subsys, oid))
    end
    return obj
end

function load_mcos_object(metadata::Any, type_name::String, subsys::Subsystem)
    @warn "Expected MCOS metadata to be an Array{UInt32}, got $(typeof(metadata)). Returning metadata."
    return metadata
end

function load_mcos_object(metadata::Dict, type_name::String, subsys::Subsystem)
    @warn "Loading enumeration instances are not supported. Returning Metadata"
    return metadata
end

function load_mcos_object(metadata::Array{UInt32}, type_name::String, subsys::Subsystem)
    try
        if length(subsys.class_id_metadata) == 0
            # Subsystem was not loaded properly
            # No need to warn again
            return metadata
        end

        if type_name != "MCOS"
            @warn "Loading Type:$type_name is not implemented. Returning metadata."
            return metadata
        end

        if metadata[1, 1] != MCOS_IDENTIFIER
            @warn "MCOS object metadata is corrupted. Returning raw data."
            return metadata
        end

        ndims = metadata[2, 1]
        dims = metadata[3:(2 + ndims), 1]
        nobjects = prod(dims)
        object_ids = metadata[(3 + ndims):(2 + ndims + nobjects), 1]

        class_id = metadata[end, 1]
        classname = get_classname(subsys, class_id)

        if nobjects == 1
            oid = object_ids[1]
            obj = get_object!(subsys, oid, classname)
            if subsys.convert_opaque
                return convert_opaque(obj; table=subsys.table_type)
            else
                return obj
            end
        else
            # no need to convert_opaque, matlab wraps object arrays in a single class normally
            object_arr = Array{MatlabOpaque}(undef, convert(Vector{Int}, dims)...)
            for i in 1:length(object_arr)
                oid = object_ids[i]
                obj = get_object!(subsys, oid, classname)
                object_arr[i] = obj
            end
            return object_arr
        end

    catch e
        @warn "Failed to load MCOS object. Returning raw metadata. Error: $e"
        return metadata
    end
end

function set_mcos_name!(subsys::Subsystem, name::String)
    idx = findfirst(isequal(name), subsys.mcos_names)
    if idx !== nothing
        return UInt32(idx)
    else
        push!(subsys.mcos_names, name)
        subsys.num_names += UInt32(1)
        return subsys.num_names
    end
end

function check_valid_property_name(s::AbstractString)
    if match(r"^[a-zA-Z][a-zA-Z0-9_]*$", s) === nothing
        error("Invalid property name \"$s\": property names must start with a letter and contain only alphanumeric characters and underscore")
    end
end

function set_class_id!(subsys::Subsystem, classname::String)
    # number of existing class entries (each class has 4 UInt32 metadata entries)
    class_count = UInt32(length(subsys.class_id_metadata) ÷ 4 - 1) # skip class_id = 0 case

    # Check if class name already exists
    for cid in UInt32(1):UInt32(class_count)
        existing_name = get_classname(subsys, cid)
        if existing_name == classname
            return cid
        end
    end

    # Add new class metadata
    subsys.class_id_counter += UInt32(1)
    # split namespace and class name at last dot
    pos = findlast(==('.'), classname)
    if pos === nothing
        namespace = ""
        cname = classname
    else
        namespace = classname[1:pos-1]
        cname = classname[pos+1:end]
    end

    cname_idx = set_mcos_name!(subsys, cname)
    namespace_idx = pos === nothing ? UInt32(0) : set_mcos_name!(subsys, namespace)

    append!(subsys.class_id_metadata, UInt32[namespace_idx, cname_idx, 0, 0])
    append!(subsys.mcos_class_alias_metadata, Int32[0]) # Placeholder for no aliases

    return subsys.class_id_counter
end

save_nested_props(prop_value, subsys::Subsystem) = prop_value

# Prop values are copied to avoid mutating original with object metadata
# Should be cheap as underlying data will be shared by reference unless modified

function save_nested_props(
    prop_value::Union{AbstractDict,MatlabStructArray}, subsys::Subsystem
)
    # Save nested objects in structs
    prop_value_copy = copy(prop_value)
    for (key, value) in prop_value
        prop_value_copy[key] = save_nested_props(value, subsys)
    end
    return prop_value_copy
end

function save_nested_props(prop_value::Array{Any}, subsys::Subsystem)
    # Save nested objects in a Cell
    prop_value_copy = copy(prop_value)
    for i in eachindex(prop_value)
        prop_value_copy[i] = save_nested_props(prop_value[i], subsys)
    end
    return prop_value_copy
end

function save_nested_props(prop_value::Union{MatlabOpaque, Array{MatlabOpaque}}, subsys::Subsystem)
    # Nested objects are saved by the uint32 Matrix signature
    # however they don't have any mxOPAQUE_CLASS headers
    # so we search within containers here

    # FIXME: Does this overwrite prop_value from the user dict?
    # Might have to create a copy instead - Test needed
    prop_metadata = set_mcos_object_metadata(subsys, prop_value)
    return prop_metadata
end

function serialize_object_props!(subsys::Subsystem, obj::MatlabOpaque, obj_prop_metadata::Vector{UInt32})

    object_id = subsys.obj_id_counter
    nprops = length(obj)

    # property metadata format: [num_props, (prop_name_idx, prop_type, prop_value_idx)*]
    push!(obj_prop_metadata, UInt32(nprops))

    for (prop_name, prop_value) in obj
        if startswith(prop_name, "__dynamic_property_")
            @warn "Dynamic properties are not supported when writing: skipping $prop_name"
            continue
        end

        check_valid_property_name(prop_name)

        field_name_idx = set_mcos_name!(subsys, prop_name)
        prop_value = save_nested_props(prop_value, subsys)

        prop_vals = UInt32[field_name_idx, 1, 0]

        cell_idx = length(subsys.prop_vals_saved) # these are zero-indexed in matlab
        push!(subsys.prop_vals_saved, prop_value)
        prop_vals[3] = cell_idx
        append!(obj_prop_metadata, prop_vals)
    end

    if length(obj_prop_metadata) % 2 == 1
        push!(obj_prop_metadata, UInt32(0)) # padding
    end

    # placeholder for dynamic props
    append!(subsys.dynprop_metadata, UInt32[0, 0])

    ndeps = subsys.obj_id_counter - object_id
    return ndeps
end

function set_object_id(subsys::Subsystem, obj::MatlabOpaque, saveobj_ret_type=false)

    if length(obj) == 0
        # This is a deleted object
        # MATLAB keeps weak references to deleted objects for some reason
        class_id = set_class_id!(subsys, obj.class)
        obj_id = UInt32(0)
        return obj_id, class_id
    end

    if haskey(subsys.save_object_cache, obj)
        class_id = set_class_id!(subsys, obj.class)
        obj_id = subsys.save_object_cache[obj]
        return obj_id, class_id
    end

    subsys.obj_id_counter += UInt32(1)
    mat_obj_id = subsys.obj_id_counter
    subsys.save_object_cache[obj] = mat_obj_id

    prop_metadata = UInt32[]
    saveobj_id = 0
    normobj_id = 0

    if saveobj_ret_type
        subsys.saveobj_counter += UInt32(1)
        saveobj_id = subsys.saveobj_counter
        push!(subsys.saveobj_prop_metadata, prop_metadata)
    else
        subsys.normalobj_counter += UInt32(1)
        normobj_id = subsys.normalobj_counter
        push!(subsys.obj_prop_metadata, prop_metadata)
    end

    obj_id_metadata = zeros(UInt32, 6)
    push!(subsys.object_id_metadata, obj_id_metadata)

    if saveobj_ret_type && !(length(obj) == 1 && haskey(obj, "any"))
        error("Object of class $(obj.classname) marked with a saveobj return type must have a single property 'any' containing the return value of its saveobj method")
    end

    ndeps = serialize_object_props!(subsys, obj, prop_metadata)

    class_id = set_class_id!(subsys, obj.class)
    obj_id_metadata[1] = class_id
    if saveobj_ret_type
        obj_id_metadata[4] = saveobj_id
    else
        obj_id_metadata[5] = normobj_id
    end

    # it works idk how
    obj_id_metadata[6] = mat_obj_id + ndeps
    for i in 1:ndeps
        obj_id = subsys.obj_id_counter - ndeps + i
        subsys.object_id_metadata[obj_id + 1][6] -= 1
    end

    return mat_obj_id, class_id
end

function create_mcos_metadata_array(dims::Tuple{Vararg{Int}}, arr_ids::Vector{UInt32}, class_id::UInt32)
    ndims = length(dims)
    metadata = UInt32[]
    push!(metadata, MCOS_IDENTIFIER)
    push!(metadata, UInt32(ndims))
    for d in dims
        push!(metadata, UInt32(d))
    end
    for oid in arr_ids
        push!(metadata, oid)
    end
    push!(metadata, class_id)

    return reshape(metadata, :, 1)
end

function set_mcos_object_metadata(subsys::Subsystem, obj::Array{MatlabOpaque})

    arr_ids = UInt32[]
    if length(obj) == 0
        # TODO: Handle 1x0, 0x0, 0x1 objects
        # placeholder for empty array case
        dims = size(obj)
        return create_mcos_metadata_array(dims, UInt32(0), UInt32(0))
    end
    classname = first(obj).class

    # this is not needed but added for consistency
    # future update can support mentioning classes with saveobj methods
    saveobj_ret_type = classname in matlab_saveobj_ret_types

    class_id = UInt32(0)
    for obj_elem in obj
        obj_id, class_id = set_object_id(subsys, obj_elem, saveobj_ret_type)
        append!(arr_ids, obj_id)
    end

    dims = size(obj)
    return create_mcos_metadata_array(dims, arr_ids, class_id)
end

function set_mcos_object_metadata(subsys::Subsystem, obj::MatlabOpaque)

    classname = obj.class
    saveobj_ret_type = classname in matlab_saveobj_ret_types

    object_id, class_id = set_object_id(subsys, obj, saveobj_ret_type)
    dims = (1, 1)
    return create_mcos_metadata_array(dims, [object_id], class_id)
end

function set_fwrap_metadata!(subsys::Subsystem)

    version_bytes = vec(reinterpret(UInt8, UInt32[FWRAP_VERSION]))
    num_names_bytes = copy(vec(reinterpret(UInt8, UInt32[subsys.num_names])))

    region_offsets = zeros(UInt32, 8)

    names_str = isempty(subsys.mcos_names) ? "" : join(subsys.mcos_names, '\0') * '\0'
    names_bytes = collect(codeunits(names_str))
    pad_len = (8 - (length(names_bytes) % 8)) % 8
    if pad_len > 0
        append!(names_bytes, zeros(UInt8, pad_len))
    end

    region1_bytes = vec(reinterpret(UInt8, subsys.class_id_metadata))
    region_offsets[1] = UInt32(40 + length(names_bytes))
    region_offsets[2] = region_offsets[1] + UInt32(length(region1_bytes))

    # This region (including id=0) does not exist if there are no saveobj type objects
    region2_bytes = UInt8[]
    if length(subsys.saveobj_prop_metadata) > 1
        for sub in subsys.saveobj_prop_metadata
            append!(region2_bytes, vec(reinterpret(UInt8, sub)))
        end
    end
    region_offsets[3] = region_offsets[2] + UInt32(length(region2_bytes))

    region3_bytes = UInt8[]
    for sub in subsys.object_id_metadata
        append!(region3_bytes, vec(reinterpret(UInt8, sub)))
    end
    region_offsets[4] = region_offsets[3] + UInt32(length(region3_bytes))

    region4_bytes = UInt8[]
    for sub in subsys.obj_prop_metadata
        append!(region4_bytes, vec(reinterpret(UInt8, sub)))
    end
    region_offsets[5] = region_offsets[4] + UInt32(length(region4_bytes))

    region5_bytes = vec(reinterpret(UInt8, subsys.dynprop_metadata))
    region_offsets[6] = region_offsets[5] + UInt32(length(region5_bytes))

    region6_bytes = UInt8[]
    region_offsets[7] = region_offsets[6] + UInt32(length(region6_bytes))

    region7_bytes = zeros(UInt8, 8)
    region_offsets[8] = region_offsets[7] + UInt32(length(region7_bytes))

    fwrap = Vector{UInt8}()
    append!(fwrap, version_bytes)
    append!(fwrap, num_names_bytes)
    append!(fwrap, vec(reinterpret(UInt8, region_offsets)))
    append!(fwrap, names_bytes)
    append!(fwrap, region1_bytes)
    append!(fwrap, region2_bytes)
    append!(fwrap, region3_bytes)
    append!(fwrap, region4_bytes)
    append!(fwrap, region5_bytes)
    append!(fwrap, region6_bytes)
    append!(fwrap, region7_bytes)

    return fwrap
end

function set_fwrap_data!(subsys::Subsystem)

    fwrap_data = Any[]
    fwrap_metadata = set_fwrap_metadata!(subsys)
    push!(fwrap_data, reshape(fwrap_metadata, :, 1))
    push!(fwrap_data, reshape(Any[], 0, 0))
    append!(fwrap_data, subsys.prop_vals_saved)

    empty_struct = EmptyStruct([1, 0])
    for i in 0:subsys.class_id_counter
        push!(subsys._c3, empty_struct)
        push!(subsys.prop_vals_defaults, empty_struct)
    end

    push!(fwrap_data, reshape(subsys._c3, :, 1))
    push!(fwrap_data, reshape(subsys.mcos_class_alias_metadata, :, 1))
    push!(fwrap_data, reshape(subsys.prop_vals_defaults, :, 1))

    fw_obj = MatlabOpaque(Dict{String,Any}("__filewrapper__" => reshape(fwrap_data, :, 1)), "FileWrapper__")
    return fw_obj
end

function set_subsystem_data!(subsys::Subsystem)
    if subsys.class_id_counter == 0
        # No MCOS objects to serialize
        return nothing
    end

    fwrap = set_fwrap_data!(subsys)
    subsys_struct = Dict{String,Any}()
    subsys_struct["MCOS"] = fwrap
    return subsys_struct
end

end

# MAT_v4.jl
# Tools for reading MATLAB v4 files in Julia
#
# Copyright (C) 2012   Simon Kornblith
# Copyright (C) 2019   Victor Saase (modified from MAT_v5.jl)
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# MATLAB's file format documentation can be found at
# http://www.mathworks.com/help/pdf_doc/matlab/matfile_format.pdf

module MAT_v4
using HDF5, SparseArrays
import Base: read, write, close

round_uint8(data) = round.(UInt8, data)
complex_array(a, b) = complex.(a, b)

mutable struct Matlabv4File <: HDF5.H5DataStore
    ios::IOStream
    swap_bytes::Bool
    varnames::Dict{String, Int64}

    Matlabv4File(ios, swap_bytes) = new(ios, swap_bytes)
end

const mLITTLE_ENDIAN = 0
const mBIG_ENDIAN = 1
const mVAX_DFLOAT = 2
const mVAX_GFLOAT = 3
const mGRAY = 4

const pTYPE = Dict(
    0 => Float64,
    1 => Float32,
    2 => Int32,
    3 => Int16,
    4 => UInt16,
    5 => UInt8
)

const tNUMERIC = 0
const tTEXT = 1
const tSPARSE = 2

const imagfREAL = 0
const imagfCOMPLEX = 1

read_bswap(f::IO, swap_bytes::Bool, ::Type{T}) where T =
    swap_bytes ? bswap(read(f, T)) : read(f, T)
function read_bswap(f::IO, swap_bytes::Bool, ::Type{T}, dim::Union{Int, Tuple{Vararg{Int}}}) where T
    d = read!(f, Array{T}(undef, dim))
    if swap_bytes
        for i = 1:length(d)
            @inbounds d[i] = bswap(d[i])
        end
    end
    d
end

function read_bswap(f::IO, swap_bytes::Bool, d::AbstractArray{T}) where T
    readbytes!(f, reinterpret(UInt8, d))
    if swap_bytes
        for i = 1:length(d)
            @inbounds d[i] = bswap(d[i])
        end
    end
    d
end

function checkv4(f::IO)
    M, O, P, T, mrows, ncols, imagf, namlen = MAT_v4.read_header(f, false)
    if 0<=M<=4 && O == 0 && 0<=P<=5 && 0<=T<=2 && mrows>=0 && ncols>=0 && 0<=imagf<=1 && namlen>0
        swap_bytes = false
        return (true, swap_bytes)
    else
        seek(f, 0)
        M, O, P, T, mrows, ncols, imagf, namlen = MAT_v4.read_header(f, true)
        if 0<=M<=4 && O == 0 && 0<=P<=5 && 0<=T<=2 && mrows>=0 && ncols>=0 && 0<=imagf<=1 && namlen>0
            swap_bytes = true
            return (true, swap_bytes)
        end
    end
    return (false, false)
end

# Read data type and number of bytes at the start of a data element
function read_header(f::IO, swap_bytes::Bool)
    dtype = read_bswap(f, swap_bytes, Int32)

    M = div(rem(dtype, 10000), 1000)
    O = div(rem(dtype, 1000), 100)
    P = div(rem(dtype, 100), 10)
    T = div(rem(dtype, 10), 1)

    mrows = read_bswap(f, swap_bytes, Int32)
    ncols = read_bswap(f, swap_bytes, Int32)
    imagf = read_bswap(f, swap_bytes, Int32)
    namlen = read_bswap(f, swap_bytes, Int32)

    M, O, P, T, mrows, ncols, imagf, namlen
end

# Read matrix data
function read_matrix(f::IO, swap_bytes::Bool)
    M, O, P, T, mrows, ncols, imagf, namlen = read_header(f, swap_bytes)
    if ncols == 0 || mrows == 0
        # If one creates a cell array using
        #     y = cell(m, n)
        # then MATLAB will save the empty cells as zero-byte matrices. If one creates a
        # empty cells using
        #     a = {[], [], []}
        # then MATLAB does not save the empty cells as zero-byte matrices. To avoid
        # surprises, we produce an empty array in both cases.
        name = strip(String(read_bswap(f, M==mBIG_ENDIAN, Vector{UInt8}(undef, namlen))), '\0')
        return (name, Matrix{Union{}}(undef, 0, 0))
    end
    name = strip(String(read_bswap(f, M==mBIG_ENDIAN, Vector{UInt8}(undef, namlen))), '\0')
    if T == tNUMERIC || T == tSPARSE
        real_data = read_bswap(f, M==mBIG_ENDIAN, Vector{pTYPE[P]}(undef, ncols*mrows))
        if T == tNUMERIC && imagf == imagfCOMPLEX
            imag_data = read_bswap(f, M==mBIG_ENDIAN, Vector{pTYPE[P]}(undef, ncols*mrows))
            data = complex.(real_data, imag_data)
        else
            data = real_data
        end
        datamat = reshape(data, Int(mrows), Int(ncols))
        if T == tNUMERIC
            return (name, datamat)
        elseif T == tSPARSE
            if size(datamat,2) == 3
                return (name, sparse(datamat[:,1], datamat[:,2], datamat[:,3]))
            else
                return (name, sparse(datamat[:,1], datamat[:,2], complex.(datamat[:,3], datamat[:,4])))
            end
        end
    elseif T == tTEXT
        if mrows > 1
            charvec = UInt8.(read_bswap(f, M==mBIG_ENDIAN, Vector{pTYPE[P]}(undef, ncols*mrows)))
            charmat = reshape(charvec, Int(mrows), Int(ncols))
            data = [String(charmat[i,:]) for i in 1:mrows]
        else
            data = String(UInt8.(read_bswap(f, M==mBIG_ENDIAN, Vector{pTYPE[P]}(undef, ncols))))
        end
        return (name, data)
    end
end

# Open MAT file for reading
matopen(ios::IOStream, endian_indicator::Bool) =
    Matlabv4File(ios, endian_indicator)

# Read whole MAT file
function read(matfile::Matlabv4File)
    seek(matfile.ios, 0)
    vars = Dict{String, Any}()
    while !eof(matfile.ios)
        (name, data) = read_matrix(matfile.ios, matfile.swap_bytes)
        vars[name] = data
    end
    vars
end

# Read only variable names
function getvarnames(matfile::Matlabv4File)
    if !isdefined(matfile, :varnames)
        seek(matfile.ios, 0)
        matfile.varnames = varnames = Dict{String, Int64}()
        while !eof(matfile.ios)
            offset = position(matfile.ios)
            M, O, P, T, mrows, ncols, imagf, namlen = read_header(matfile.ios, matfile.swap_bytes)
            f = matfile.ios

            name = strip(String(read_bswap(f, M==mBIG_ENDIAN, Vector{UInt8}(undef, namlen))), '\0')
            varnames[name] = offset
            imag_offset = 0
            skip(f, mrows*ncols*sizeof(pTYPE[P]))
            if imagf == imagfCOMPLEX
                skip(f, mrows*ncols*sizeof(pTYPE[P]))
            end
        end
    end
    matfile.varnames
end

Base.haskey(matfile::Matlabv4File, varname::String) =
    haskey(getvarnames(matfile), varname)
Base.keys(matfile::Matlabv4File) =
    keys(getvarnames(matfile))

# Read a variable from a MAT file
function read(matfile::Matlabv4File, varname::String)
    varnames = getvarnames(matfile)
    if !haskey(varnames, varname)
        error("no variable $varname in file")
    end
    seek(matfile.ios, varnames[varname])
    (name, data) = read_matrix(matfile.ios, matfile.swap_bytes)
    data
end

function colvals(A::AbstractSparseMatrix)
    rows = rowvals(A)
    cols = similar(rows)
    m,n = size(A)
    for i=1:n
        for j in nzrange(A,i)
            cols[j] = i
        end
    end
    cols
end

function write(parent::Matlabv4File, name::String, s::AbstractChar)
    write(parent, name, string(s))
end

function write(parent::Matlabv4File, name::String, s)
    M = Int(parent.swap_bytes)
    O = 0
    P = 0
    for p=keys(pTYPE)
        if eltype(s) == pTYPE[p] || eltype(s) == Complex{pTYPE[p]}
            P = p
        end
    end
    if pTYPE[P] != eltype(s) && Complex{pTYPE[P]} != eltype(s) &&
        !(s isa AbstractString && pTYPE[P] == Float64) &&
        !(s isa Vector{String} && pTYPE[P] == Float64)
        error("invalid value type when writing v4 file")
    end
    if s isa AbstractSparseMatrix
        T = tSPARSE
    elseif s isa AbstractString || s isa Vector{String}
        T = tTEXT
    else
        T = tNUMERIC
    end
    write(parent.ios, Int32(1000*M + 100*O + 10*P + T))

    mrows = 1
    ncols = 1
    if s isa AbstractVector && !(s isa Vector{String})
        ncols = length(s)
    elseif s isa AbstractMatrix
        if s isa AbstractSparseMatrix
            mrows = nnz(s)
            ncols = 3
            if eltype(s) <: Complex
                ncols = 4
            end
        else
            mrows, ncols = size(s)
        end
    elseif s isa Vector{String}
        ncols = length(s[1])
        mrows = length(s)
    elseif s isa AbstractString
        ncols = length(s)
    end
    write(parent.ios, Int32(mrows))
    write(parent.ios, Int32(ncols))

    imagf = 0
    if eltype(s) <: Complex && T == tNUMERIC
        imagf = 1
    end
    write(parent.ios, Int32(imagf))

    namlen = length(name) + 1
    write(parent.ios, Int32(namlen))

    write(parent.ios, Vector{UInt8}(name))
    write(parent.ios, UInt8(0))

    if s isa AbstractArray && T == tNUMERIC
        write(parent.ios, reshape(real(s), length(s)))
        if imagf == 1
            write(parent.ios, reshape(imag(s), length(s)))
        end
    elseif s isa Number
        write(parent.ios, real(s))
        if imagf == 1
            write(parent.ios, imag(s))
        end
    elseif s isa AbstractString
        floatarray = Float64.(Vector{UInt8}(s))
        write(parent.ios, floatarray)
    elseif s isa Vector{String}
        floatarray = Matrix{Float64}(undef, mrows, ncols)
        for (i,strel) = enumerate(s)
            floatarray[i,:] = Float64.(Vector{UInt8}(strel))
        end
        write(parent.ios, floatarray)
    elseif T == tSPARSE
        rows = rowvals(s)
        cols = colvals(s)
        vals = nonzeros(s)
        write(parent.ios, pTYPE[P].(rows))
        write(parent.ios, pTYPE[P].(cols))
        write(parent.ios, pTYPE[P].(real(vals)))
        if eltype(s) <: Complex
            write(parent.ios, pTYPE[P].(imag(vals)))
        end
    end
end

# Close MAT file
close(matfile::Matlabv4File) = close(matfile.ios)

end

# MAT_HDF5.jl
# Tools for reading MATLAB HDF5 (v7.3) files in Julia
#
# Copyright (C) 2012   Timothy E. Holy
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

###########################################
## Reading and writing MATLAB .mat files ##
###########################################

module MAT_HDF5

using HDF5, SparseArrays
using ..MAT_subsys

import Base: names, read, write, close
import HDF5: Reference
import Dates
import Tables
import PooledArrays: PooledArray

import ..MAT_types:
    convert_struct_array,
    EmptyStruct,
    MatlabClassObject,
    MatlabOpaque,
    MatlabStructArray,
    MatlabTable,
    ScalarOrArray,
    StructArrayField,
    FunctionHandle,
    decode_char_array

const HDF5Parent = Union{HDF5.File, HDF5.Group}
const HDF5BitsOrBool = Union{HDF5.BitsType,Bool}

mutable struct MatlabHDF5File <: HDF5.H5DataStore
    plain::HDF5.File
    toclose::Bool
    writeheader::Bool
    refcounter::Int
    compress::Bool
    subsystem::Subsystem

    function MatlabHDF5File(plain, toclose::Bool=true, writeheader::Bool=false, refcounter::Int=0, compress::Bool=false)
        f = new(plain, toclose, writeheader, refcounter, compress, Subsystem())
        if toclose
            finalizer(close, f)
        end
        f
    end
end

function Base.show(io::IO, f::MatlabHDF5File)
    print(io, "MatlabHDF5File(")
    print(io, f.plain, ", ")
    print(io, f.toclose, ", ")
    print(io, f.writeheader, ", ")
    print(io, f.refcounter, ", ")
    print(io, f.compress, ")")
end

"""
    close(matfile_handle)

Close a Matlab file.
"""
function close(f::MatlabHDF5File)
    if f.toclose
        close(f.plain)
        if f.writeheader
            magic = zeros(UInt8, 512)
            identifier = "MATLAB 7.3 MAT-file" # minimal but sufficient
            GC.@preserve magic identifier begin
                magicptr = pointer(magic)
                idptr = pointer(identifier)
                unsafe_copyto!(magicptr, idptr, length(identifier))
            end
            magic[126] = 0x02
            if Base.ENDIAN_BOM == 0x04030201
                magic[127] = 0x49
                magic[128] = 0x4d
            else
                magic[127] = 0x4d
                magic[128] = 0x49
            end
            rawfid = open(f.plain.filename, "r+")
            write(rawfid, magic)
            close(rawfid)
        end
        f.toclose = false
    end
    nothing
end

function matopen(filename::AbstractString, rd::Bool, wr::Bool, cr::Bool, tr::Bool, ff::Bool, compress::Bool, endian_indicator::Bool; table::Type=MatlabTable, convert_opaque::Bool=true)
    local f
    if ff && !wr
        error("Cannot append to a read-only file")
    end
    if !cr && !isfile(filename)
        error("File ", filename, " cannot be found")
    end
    fapl = HDF5.FileAccessProperties()
    fapl.fclose_degree = :strong
    if cr && (tr || !isfile(filename))
        # We're truncating, so we don't have to check the format of an existing file
        # Set the user block to 512 bytes, to save room for the header
        fcpl = HDF5.FileCreateProperties()
        fcpl.userblock = 512
        f = HDF5.API.h5f_create(filename, HDF5.API.H5F_ACC_TRUNC, fcpl, fapl)
        writeheader = true
    else
        f = HDF5.API.h5f_open(filename, wr ? HDF5.API.H5F_ACC_RDWR : HDF5.API.H5F_ACC_RDONLY, fapl)
        writeheader = false
    end
    close(fapl)
    fid = MatlabHDF5File(HDF5.File(f, filename), true, writeheader, 0, compress)
    pathrefs = "/#refs#"
    if haskey(fid.plain, pathrefs)
        g = fid.plain[pathrefs]
        fid.refcounter = length(g)-1
        close(g)
    end
    subsys_refs = "#subsystem#"
    if rd && haskey(fid.plain, subsys_refs)
        fid.subsystem.table_type = table
        fid.subsystem.convert_opaque = convert_opaque
        subsys_group::HDF5.Group = fid.plain[subsys_refs]
        HDF5.name(subsys_group) == "/#subsystem#" || error("Invalid subsystem group name")
        subsys_data = m_read(subsys_group, fid.subsystem, "#subsystem#")
        MAT_subsys.load_subsys!(fid.subsystem, subsys_data, endian_indicator)
        close(subsys_group)
    elseif wr
        MAT_subsys.init_save!(fid.subsystem)
    end
    fid
end

### Matlab file format specification ###

const name_type_attr_matlab = "MATLAB_class"
const empty_attr_matlab = "MATLAB_empty"
const sparse_attr_matlab = "MATLAB_sparse"
const int_decode_attr_matlab = "MATLAB_int_decode"
const object_type_attr_matlab = "MATLAB_object_decode"
const object_decode_attr_matlab = "MATLAB_object_decode"
const struct_field_attr_matlab = "MATLAB_fields"

const matlab_function_decode = UInt32(1)
const matlab_object_decode = UInt32(2)
const matlab_opaque_decode = UInt32(3)

### Reading
function read_complex(dtype::HDF5.Datatype, dset::HDF5.Dataset, ::Type{T}) where T
    if !check_datatype_complex(dtype)
        close(dtype)
        error("Unrecognized compound data type when reading ", HDF5.name(dset))
    end
    return read(dset, Complex{T})
end

function read_cell(dset::HDF5.Dataset, subsys::Subsystem)
    refs = read(dset, Reference)
    out = Array{Any}(undef, size(refs))
    f = HDF5.file(dset)
    for i = 1:length(refs)
        dset = f[refs[i]]
        try
            out[i] = m_read(dset, subsys)
        finally
            close(dset)
        end
    end
    return out
end

function m_read(dset::HDF5.Dataset, subsys::Subsystem)
    if haskey(dset, empty_attr_matlab)
        # Empty arrays encode the dimensions as the dataset
        dims = convert(Vector{Int}, read(dset))
        mattype = read_attribute(dset, name_type_attr_matlab)
        if mattype == "char"
            return String[]
        elseif mattype == "struct"
            # Not sure if this check is necessary but it is checked in
            # `m_read(g::HDF5.Group)`
            if haskey(dset, struct_field_attr_matlab)
                field_names = [join(n) for n in read_attribute(dset, struct_field_attr_matlab)]
                return MatlabStructArray(field_names, tuple(dims...))
            else
                return Dict{String,Any}()
            end
        else
            T = mattype == "canonical empty" ? Union{} : str2type_matlab[mattype]
            return Array{T}(undef, dims...)
        end
    end

    objecttype = haskey(dset, object_type_attr_matlab) ? read_attribute(dset, object_type_attr_matlab) : nothing
    mattype = haskey(dset, name_type_attr_matlab) ? read_attribute(dset, name_type_attr_matlab) : "struct_array_field"

    if mattype == "cell" && objecttype === nothing
        # Cell arrays, represented as an array of refs
        return read_cell(dset, subsys)
    elseif objecttype !== nothing
        if objecttype != 3
            @warn "MATLAB Object Type $mattype is currently not supported."
            return missing
        end
        if mattype == "FileWrapper__"
            return read_cell(dset, subsys)
        end
        if haskey(dset, struct_field_attr_matlab)
            @warn "Enumeration Instances are not supported currently."
            return missing
        end
    elseif mattype == "struct_array_field"
        # This will be converted into MatlabStructArray in `m_read(g::HDF5.Group)`
        return StructArrayField(read_cell(dset, subsys))
    elseif !haskey(str2type_matlab,mattype)
        @warn "MATLAB $mattype values are currently not supported."
        return missing
    end

    # Regular arrays of values
    # Convert to Julia type
    if objecttype === nothing
        T = str2type_matlab[mattype]
    else
        T = UInt32 # FIXME: Default for MATLAB objects?
    end

    # Check for a COMPOUND data set, and if so handle complex numbers specially
    dtype = datatype(dset)
    try
        class_id = HDF5.API.h5t_get_class(dtype.id)
        d = class_id == HDF5.API.H5T_COMPOUND ? read_complex(dtype, dset, T) : read(dset, T)
        if objecttype !== nothing
            return MAT_subsys.load_mcos_object(d, "MCOS", subsys)
        else
            return length(d) == 1 ? d[1] : d
        end
    finally
        close(dtype)
    end
end

function add!(A, x)
    for i = 1:length(A)
        @inbounds A[i] += x
    end
    A
end

function read_sparse_matrix(g::HDF5.Group, mattype::String)
    local data
    fn = keys(g)
    # ir is the row indices, jc is the column boundaries.
    # We add one to account for the zero-based (MATLAB) to one-based (Julia) transition
    jc = add!(convert(Vector{Int}, read(g, "jc")), 1)
    if "data" in fn && "ir" in fn && "jc" in fn
        # This matrix is not empty.
        ir = add!(convert(Vector{Int}, read(g, "ir")), 1)
        dset = g["data"]
        T = str2type_matlab[mattype]
        try
            dtype = datatype(dset)
            class_id = HDF5.API.h5t_get_class(dtype.id)
            try
                data = class_id == HDF5.API.H5T_COMPOUND ? read_complex(dtype, dset, T) : read(dset, T)
            finally
                close(dtype)
            end
        finally
            close(dset)
        end
    else
        # This matrix is empty.
        ir = Int[]
        data = str2type_matlab[mattype][]
    end
    return SparseMatrixCSC(convert(Int, read_attribute(g, sparse_attr_matlab)), length(jc)-1, jc, ir, data)
end

function read_struct_as_dict(g::HDF5.Group, subsys::Subsystem)
    if haskey(g, struct_field_attr_matlab)
        fn = [join(f) for f in read_attribute(g, struct_field_attr_matlab)]
    else
        fn = keys(g)
    end
    s = Dict{String, Any}()
    for i = 1:length(fn)
        dset = g[fn[i]]
        try
            s[fn[i]] = m_read(dset, subsys)
        finally
            close(dset)
        end
    end
    return s
end

# reading a struct, struct array, or sparse matrix
function m_read(g::HDF5.Group, subsys::Subsystem)
    mattype = read_attribute(g, name_type_attr_matlab)
    return m_read(g, subsys, mattype)
end

function m_read(g::HDF5.Group, subsys::Subsystem, mattype::String)
    is_object = false
    if mattype != "struct"
        attr = attributes(g)
        # Check if this is a sparse matrix.
        if haskey(attr, sparse_attr_matlab)
            return read_sparse_matrix(g, mattype)
        elseif mattype == "function_handle"
            if haskey(attr, object_decode_attr_matlab) && read_attribute(g, object_decode_attr_matlab)==1
                is_object = true
            end
        else
            if haskey(attr, object_decode_attr_matlab) && read_attribute(g, object_decode_attr_matlab)==2
                # I think this means it's an old object class similar to mXOBJECT_CLASS in MAT_v5
                is_object = true
            elseif mattype != "#subsystem#"
                @warn "Unknown non-struct group of type $mattype detected; attempting to read as struct"
            end
        end
    end
    if is_object
        class = mattype
    else
        class = ""
    end
    s = read_struct_as_dict(g, subsys)
    out = convert_struct_array(s, class)
    return out
end

"""
    read(matfile_handle, varname) -> value

Read a variable from an opened Matlab file and return its value.

See `matopen` and `matread`.
"""
function read(f::MatlabHDF5File, name::String)
    local val
    obj = f.plain[name]
    try
        val = m_read(obj, f.subsystem)
    finally
        close(obj)
    end
    val
end

"""
    keys(matfile_handle) -> Vector{String}

Return a list of variables in an opened Matlab file.

See `matopen`.
"""
Base.keys(f::MatlabHDF5File) = filter!(x -> x!="#refs#" && x!="#subsystem#", keys(f.plain))

"""
    haskey(matfile_handle, varname) -> Bool

Return true if a variable is present in an opened Matlab file.

See `matopen`.
"""
Base.haskey(p::MatlabHDF5File, path::String) = haskey(p.plain, path)

### Writing

# Check whether a varname is valid for MATLAB
check_valid_varname(s::AbstractString) = if match(r"^[a-zA-Z][a-zA-Z0-9_]*$", s) == nothing
    error("Invalid variable name or key \"$s\": variable names must start with a letter and contain only alphanumeric characters and underscore")
elseif length(s) > 63
    error("Invalid variable name or key \"$s\": variable names must be less than 64 characters")
end

toarray(x::Array) = x
toarray(x::Array{Bool}) = reinterpret(UInt8, x)
toarray(x::Bool) = UInt8[x]
toarray(x) = [x]

# Write the MATLAB type string for dset
m_writetypeattr(dset, ::Type{Complex{T}}) where T = m_writetypeattr(dset, T)
function m_writetypeattr(dset, T)
    if !haskey(type2str_matlab, T)
        error("Type ", T, " is not (yet) supported")
    end
    typename = type2str_matlab[T]

    # Write the attribute
    write_attribute(dset, name_type_attr_matlab, typename)
    if T == Bool
        write_attribute(dset, int_decode_attr_matlab, Int32(1))
    end
end

# Writes an empty scalar or array
function m_writeempty(parent::HDF5Parent, name::String, data::AbstractArray)
    adata = [size(data)...]
    dset, dtype = create_dataset(parent, name, adata)
    try
        write_attribute(dset, empty_attr_matlab, 0x01)
        m_writetypeattr(dset, eltype(data))
        write_dataset(dset, dtype, adata)
    finally
        close(dset)
        close(dtype)
    end
end

# Write an array to a dataset in a MATLAB file, returning the dataset
function m_writearray(parent::HDF5Parent, name::String, adata::AbstractArray{T}, compress::Bool) where {T<:HDF5BitsOrBool}
    if compress
        dset, dtype = create_dataset(parent, name, adata;
                               deflate = 3, chunk = HDF5.heuristic_chunk(adata))
    else
        dset, dtype = create_dataset(parent, name, adata)
    end
    try
        write_dataset(dset, dtype, adata)
        dset
    catch e
        close(dset)
        rethrow(e)
    finally
        close(dtype)
    end
end
function m_writearray(parent::HDF5Parent, name::String, adata::AbstractArray{Complex{T}}, compress::Bool) where {T<:HDF5BitsOrBool}
    dtype = build_datatype_complex(T)
    try
        stype = dataspace(adata)
        if compress
            dset = create_dataset(parent, name, dtype, stype;
                              deflate = 3, chunk = HDF5.heuristic_chunk(adata))
        else
            dset = create_dataset(parent, name, dtype, stype)
        end
        try
            arr = reshape(reinterpret(T, adata), tuple(2, size(adata)...))
            write_dataset(dset, dtype, arr)
        catch e
            close(dset)
            rethrow(e)
        finally
            close(stype)
        end
        return dset
    finally
        close(dtype)
    end
end

function _normalize_arr(x)
    if x isa Array
        x
    elseif x isa AbstractArray
        collect(x)
    else
        x
    end
end

# Write a scalar or array
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, data::Union{T, Complex{T}, AbstractArray{T}, AbstractArray{Complex{T}}}, ) where {T<:HDF5BitsOrBool}
    data = _normalize_arr(data)
    if isempty(data)
        m_writeempty(parent, name, data)
        return
    end
    dset = m_writearray(parent, name, toarray(data), mfile.compress)
    try
        m_writetypeattr(dset, T)
    finally
        close(dset)
    end
end

# Write sparse arrays
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, data::SparseMatrixCSC{T}) where T
    g = create_group(parent, name)
    try
        m_writetypeattr(g, T)
        write_attribute(g, sparse_attr_matlab, UInt64(size(data, 1)))
        if !isempty(data.nzval)
            close(m_writearray(g, "data", toarray(data.nzval), mfile.compress))
            close(m_writearray(g, "ir", add!(isa(data.rowval, Vector{UInt64}) ? copy(data.rowval) : convert(Vector{UInt64}, data.rowval), typemax(UInt64)), mfile.compress))
        end
        close(m_writearray(g, "jc", add!(isa(data.colptr, Vector{UInt64}) ? copy(data.colptr) : convert(Vector{UInt64}, data.colptr), typemax(UInt64)), mfile.compress))
    finally
        close(g)
    end
end

# Write BitArray as Array{Bool}. Would be better not to require the conversion, but this is easy
m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s::BitArray) =
    m_write(mfile, parent, name, convert(Array{Bool}, s))

# Write strings/chars
function encode_char_array(A::AbstractArray{<:AbstractChar})
    # Encodes Julia char into MATLAB char array format
    # Each char is transcoded to UTF-16, which can have 1 or 2 code units
    # Expand 2nd dim, pad rows with spaces for uniform width
    encoded = map(c -> transcode(UInt16, string(c)), A)
    max_units = maximum(length, encoded)

    d1 = size(A, 1)
    d2 = ndims(A) == 1 ? 1 : size(A, 2)
    trailing = ndims(A) <= 2 ? () : size(A)[3:end]
    out = fill(UInt16(' '), d1, d2 * max_units, trailing...)

    for idx in CartesianIndices(A)
        units = encoded[idx]
        row = idx[1]
        col = ndims(A) == 1 ? 1 : idx[2]
        rest = ndims(A) <= 2 ? () : Tuple(idx)[3:ndims(A)]  # fix: explicit end
        col_start = (col - 1) * max_units + 1
        out[row, col_start:col_start+length(units)-1, rest...] = units
    end

    return out
end

function encode_char_array(A::AbstractArray{<:AbstractString})
    # Encode Julia strings into MATLAB char arrays
    # Each string is transcoded to UTF-16
    # Expand into new dimension for max char length, pad with spaces for uniform width
    flat = vec(A)
    encoded = Vector{Vector{UInt16}}(undef, length(flat))
    max_units = 0
    for i in eachindex(flat)
        units = transcode(UInt16, flat[i])
        encoded[i] = units
        max_units = max(max_units, length(units))
    end

    out = fill(UInt16(' '), length(flat), max_units)
    for i in eachindex(encoded)
        out[i, 1:length(encoded[i])] = encoded[i]
    end

    reshaped = reshape(out, size(A)..., max_units)
    perm = (1, ndims(reshaped), 2:ndims(reshaped)-1...)
    return permutedims(reshaped, perm)
end

# Single strings/chars
m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s::AbstractString) =
    m_write(mfile, parent, name, reshape([s], 1, 1))

m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, c::AbstractChar) =
    m_write(mfile, parent, name, reshape([c], 1, 1))

# String/Char Arrays
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, data::Union{AbstractArray{<:AbstractString}, AbstractArray{<:AbstractChar}})
    str = string.(data)
    if length(data) == 1 && isempty(data[1])
        data = UInt64[0, 0]

        # Create the dataset
        dset, dtype = create_dataset(parent, name, data)
        try
            write_attribute(dset, name_type_attr_matlab, "char")
            write_attribute(dset, empty_attr_matlab, 0x01)
            write_dataset(dset, dtype, data)
        finally
            close(dset)
            close(dtype)
        end
    else
        encoded = encode_char_array(data)
        dset, dtype = create_dataset(parent, name, encoded)
        try
            write_attribute(dset, name_type_attr_matlab, "char")
            write_attribute(dset, int_decode_attr_matlab, Int32(2))
            write_dataset(dset, dtype, encoded)
        finally
            close(dset)
            close(dtype)
        end
    end
end

# Tuple
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, t::Tuple)
    m_write(mfile, parent, name, [x for x in t])
end

# Symbol
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s::Symbol)
    m_write(mfile, parent, name, string(s))
end

# Write cell arrays
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, data::AbstractArray{T}, object_decode::UInt32=UInt32(0)) where T
    data = _normalize_arr(data)
    refs = _write_references(mfile, parent, data)
    # Write the references as the chosen variable
    cset, ctype = create_dataset(parent, name, refs)
    try
        write_dataset(cset, ctype, refs)
        if object_decode == UInt32(3)
            write_attribute(cset, object_decode_attr_matlab, object_decode)
            write_attribute(cset, name_type_attr_matlab, "FileWrapper__")
        else
            write_attribute(cset, name_type_attr_matlab, "cell")
        end
    finally
        close(ctype)
        close(cset)
    end
end

function _write_references(mfile::MatlabHDF5File, parent::HDF5Parent, data::AbstractArray)
    pathrefs = "/#refs#"
    fid = HDF5.file(parent)
    local g
    local refs
    if !haskey(fid, pathrefs)
        g = create_group(fid, pathrefs)
    else
        g = fid[pathrefs]
    end
    try
        # If needed, create the "empty" item
        if !haskey(g, "a")
            edata = zeros(UInt64, 2)
            eset, etype = create_dataset(g, "a", edata)
            try
                write_dataset(eset, etype, edata)
                write_attribute(eset, name_type_attr_matlab, "canonical empty")
                write_attribute(eset, "MATLAB_empty", 0x00)
            finally
                close(etype)
                close(eset)
            end
        else
            a = g["a"]
            if !haskey(attributes(a), "MATLAB_empty")
                close(a)
                error("Must create the empty item, with name a, first")
            end
            close(a)
        end
        # Write the items to the reference group
        refs = Array{Reference}(undef, size(data))
        for i = 1:length(data)
            mfile.refcounter += 1
            itemname = string(mfile.refcounter)
            m_write(mfile, g, itemname, data[i])
            # Extract references
            tmp = g[itemname]
            refs[i] = Reference(tmp, pathrefs*"/"*itemname)
            close(tmp)
        end
    finally
        close(g)
    end
    return refs
end

function _write_field_reference(mfile::MatlabHDF5File, parent::HDF5Parent, k::Vector{String})
    pathrefs = "/#refs#"
    fid = HDF5.file(parent)
    local g
    local ref
    if !haskey(fid, pathrefs)
        g = create_group(fid, pathrefs)
    else
        g = fid[pathrefs]
    end

    try
        mfile.refcounter +=1
        itemname = string(mfile.refcounter)
        cset, ctype = create_dataset(g, itemname, HDF5.VLen(k))
        write_dataset(cset, ctype, HDF5.VLen(k))
        tmp = g[itemname]
        ref = Reference(tmp, pathrefs*"/"*itemname)
        close(tmp)
    finally
        close(g)
    end
    return ref
end

function _write_struct_fields(mfile::MatlabHDF5File, parent::Union{HDF5.Group, HDF5.Dataset}, fieldnames::Vector{String})
    total_chars = sum(length, fieldnames)
    if total_chars < 4096
        write_attribute(parent, struct_field_attr_matlab, HDF5.VLen(fieldnames))
    else
        # Write Reference instead
        ref = _write_field_reference(mfile, parent, fieldnames)
        write_attribute(parent, struct_field_attr_matlab, ref)
    end
end

# Struct array: Array of Dict => MATLAB struct array
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, arr::AbstractArray{<:AbstractDict})
    m_write(mfile, parent, name, MatlabStructArray(arr))
end

# MATLAB struct array
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, arr::MatlabStructArray)
    first_value = first(arr.values)
    if isempty(first_value)
        # write an empty struct array
        adata = [size(first_value)...]
        dset, dtype = create_dataset(parent, name, adata)
        try
            write_attribute(dset, empty_attr_matlab, 0x01)
            write_attribute(dset, name_type_attr_matlab, "struct")
            _write_struct_fields(mfile, dset, arr.names)
            write_dataset(dset, dtype, adata)
        finally
            close(dtype); close(dset)
        end
    else
        g = create_group(parent, name)
        try
            if isempty(arr.class)
                write_attribute(g, name_type_attr_matlab, "struct")
                _write_struct_fields(mfile, g, arr.names)
            else
                write_attribute(g, name_type_attr_matlab, arr.class)
                write_attribute(g, object_decode_attr_matlab, UInt32(2))
                _write_struct_fields(mfile, g, arr.names)
            end
            for (fieldname, field_values) in arr
                refs = _write_references(mfile, parent, field_values)
                dset, dtype = create_dataset(g, fieldname, refs)
                try
                    write_dataset(dset, dtype, refs)
                finally
                    close(dtype); close(dset)
                end
            end
        finally
            close(g)
        end
    end
end

# Check that keys are valid for a struct, and convert them to an array of ASCIIStrings
function check_struct_keys(k::Vector)
    asckeys = Vector{String}(undef, length(k))
    for i = 1:length(k)
        key = k[i]
        if !isa(key, AbstractString)
            error("Only Dicts with string keys may be saved as MATLAB structs")
        end
        check_valid_varname(key)
        asckeys[i] = convert(String, key)
    end
    asckeys
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, obj::FunctionHandle)
    g = create_group(parent, name)
    try
        write_attribute(g, name_type_attr_matlab, "function_handle")
        write_attribute(g, object_decode_attr_matlab, matlab_function_decode)
        obj_struct = obj.d
        all_keys = collect(keys(obj_struct))
        _write_struct_fields(mfile, g, all_keys)
        for (ki, vi) in zip(all_keys, values(obj_struct))
            m_write(mfile, g, ki, vi)
        end
    finally
        close(g)
    end
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, arr::AbstractArray{MatlabClassObject})
    m_write(mfile, parent, name, MatlabStructArray(arr))
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, obj::MatlabClassObject)
    g = create_group(parent, name)
    try
        write_attribute(g, name_type_attr_matlab, obj.class)
        write_attribute(g, object_decode_attr_matlab, matlab_object_decode)
        all_keys = collect(keys(obj))
        _write_struct_fields(mfile, g, all_keys)
        for (ki, vi) in zip(all_keys, values(obj))
            m_write(mfile, g, ki, vi)
        end
    finally
        close(g)
    end
end

# Write empty (zero-dimensional) structs with no fields
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s::EmptyStruct)
    dset, dtype = create_dataset(parent, name, s.dims)
    try
        write_attribute(dset, empty_attr_matlab, 0x01)
        write_attribute(dset, name_type_attr_matlab, "struct")
        write_dataset(dset, dtype, s.dims)
    finally
        close(dtype); close(dset)
    end
end

# Write a struct from arrays of keys and values
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, k::Vector{String}, v::Vector)
    if length(k) == 0
        # empty struct
        adata = UInt64[1, 1]
        dset, dtype = create_dataset(parent, name, adata)
        try
            write_attribute(dset, empty_attr_matlab, 0x01)
            write_attribute(dset, name_type_attr_matlab, "struct")
            write_dataset(dset, dtype, adata)
        finally
            close(dtype); close(dset)
        end
        return
    end

    g = create_group(parent, name)
    try
        write_attribute(g, name_type_attr_matlab, "struct")
        for i = 1:length(k)
            m_write(mfile, g, k[i], v[i])
        end
        _write_struct_fields(mfile, g, k)
    finally
        close(g)
    end
end

# Write Associative as a struct
m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s::AbstractDict) =
    m_write(mfile, parent, name, check_struct_keys(collect(keys(s))), collect(values(s)))

# Write named tuple as a struct
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, nt::NamedTuple)
    m_write(mfile, parent, name, [string(x) for x in keys(nt)], collect(nt))
end

# Write generic CompositeKind as a struct
function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, s)
    if isbits(s)
        error("This is the write function for CompositeKind, but the input doesn't fit")
    elseif Tables.istable(s)
        error("writing tables is not yet supported")
    end
    T = typeof(s)
    m_write(mfile, parent, name, check_struct_keys([string(x) for x in fieldnames(T)]), [getfield(s, x) for x in fieldnames(T)])
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, dat::ScalarOrArray{T}) where T<:Dates.AbstractTime
    error("writing of type $T is not yet supported")
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, dat::ScalarOrArray{T}) where T<:Union{Dates.DateTime, Dates.Millisecond}
    m_write(mfile, parent, name, MatlabOpaque(dat))
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, obj::MatlabOpaque)
    if obj.class == "FileWrapper__"
        m_write(mfile, parent, name, obj["__filewrapper__"], UInt32(3))
        return
    end

    metadata = MAT_subsys.set_mcos_object_metadata(mfile.subsystem, obj)
    dset, dtype = create_dataset(parent, name, metadata)
    try
        write_dataset(dset, dtype, metadata)
        write_attribute(dset, name_type_attr_matlab, obj.class)
        write_attribute(dset, object_type_attr_matlab, matlab_opaque_decode)
    finally
        close(dset)
        close(dtype)
    end
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, obj::AbstractArray{MatlabOpaque})
    metadata = MAT_subsys.set_mcos_object_metadata(mfile.subsystem, obj)
    dset, dtype = create_dataset(parent, name, metadata)
    try
        # TODO: Handle empty array case
        write_dataset(dset, dtype, metadata)
        write_attribute(dset, name_type_attr_matlab, first(obj).class)
        write_attribute(dset, object_type_attr_matlab, matlab_opaque_decode)
    finally
        close(dset)
        close(dtype)
    end
end

function m_write(mfile::MatlabHDF5File, parent::HDF5Parent, name::String, arr::PooledArray)
    error("writing of PooledArray types as categorical is not yet supported")
end

# Check whether a variable name is valid, then write it
"""
    write(matfile_handle, varname, value)

Write the value into an opened Matlab file as the specified variable.

See `matopen` and `matwrite`.
"""
function write(parent::MatlabHDF5File, name::String, thing)
    check_valid_varname(name)
    m_write(parent, parent.plain, name, thing)
end

function write_subsys(mfile::MatlabHDF5File, subsys_data::Dict{String,Any})
    name = "#subsystem#"
    m_write(mfile, mfile.plain, name, subsys_data)
end

## Type conversion operations ##

struct MatlabString end

const str2type_matlab = Dict(
    "canonical empty" => nothing,
    "int8"    => Int8,
    "uint8"   => UInt8,
    "int16"   => Int16,
    "uint16"  => UInt16,
    "int32"   => Int32,
    "uint32"  => UInt32,
    "int64"   => Int64,
    "uint64"  => UInt64,
    "single"  => Float32,
    "double"  => Float64,
    "cell"    => Any,
    "char"    => MatlabString,
    "logical" => Bool
)
const type2str_matlab = Dict(
    Int8    => "int8",
    UInt8   => "uint8",
    Int16   => "int16",
    UInt16  => "uint16",
    Int32   => "int32",
    UInt32  => "uint32",
    Int64   => "int64",
    UInt64  => "uint64",
    Float32 => "single",
    Float64 => "double",
    Bool    => "logical"
)


function read(obj::Union{HDF5.Dataset,HDF5.Attribute}, ::Type{MatlabString})
    T = HDF5.get_jl_type(obj)
    data = read(obj, T)
    return decode_char_array(data, :utf16)
end

## Utilities for handling complex numbers
function build_datatype_complex(T::Type)
    memtype = create_datatype(HDF5.API.H5T_COMPOUND, 2*sizeof(T))
    HDF5.API.h5t_insert(memtype, "real", 0, HDF5.hdf5_type_id(T))
    HDF5.API.h5t_insert(memtype, "imag", sizeof(T), HDF5.hdf5_type_id(T))
    return memtype
end

function check_datatype_complex(dtype::HDF5.Datatype)
    n = HDF5.API.h5t_get_nmembers(dtype.id)
    if n != 2
        return false
    end
    if HDF5.API.h5t_get_member_name(dtype.id, 0) != "real" ||
       HDF5.API.h5t_get_member_name(dtype.id, 1) != "imag"
        return false
    end
    true
end

end

```@meta
CurrentModule = MAT
```

# MAT.jl Documentation

## Overview

This Julia package
[(MAT.jl)](https://github.com/JuliaIO/MAT.jl)
provides tools
for reading and writing MATLAB format data files in Julia.

## Basic Usage

To read a single variable from a MAT file (compressed files are detected and handled automatically):

```julia
using MAT
file = matopen("matfile.mat")
read(file, "varname") # note that this does NOT introduce a variable ``varname`` into scope
close(file)
```

To write a variable to a MAT file:

```julia
file = matopen("matfile.mat", "w")
write(file, "varname", variable)
close(file)
```

To read all variables from a MAT file as a Dict:

```julia
vars = matread("matfile.mat")
```

To write a Dict to a MAT file, using its keys as variable names.
The `compress` argument is optional, and compression is off by default:

```julia
matwrite("matfile.mat", Dict(
	"myvar1" => 0,
	"myvar2" => 1
); compress = true)
```

To write in MATLAB v4 format:

```julia
matwrite("matfile.mat", Dict(
	"myvar1" => 0,
	"myvar2" => 1
);version="v4")
```

To get a list of variable names in a MAT file:

```julia
file = matopen("matfile.mat")
varnames = keys(file)
close(file)
```

To check for the presence of a variable name in a MAT file:

```julia
file = matopen("matfile.mat")
if haskey(file, "variable")
    # something
end
close(file)
```

# Objects and struct arrays

To better handle special cases we have these types since MAT 0.11:
* [`MatlabStructArray`](@ref MatlabStructArray)
* [`MatlabClassObject`](@ref MatlabClassObject)

## Struct arrays vs Cell arrays

Cell arrays are written for `Array{Any}` or any other unsupported element type:

```julia
sarr = Any[
    Dict("x"=>1.0, "y"=>2.0),
    Dict("x"=>3.0, "y"=>4.0)
]
matwrite("matfile.mat", Dict("cell" => sarr))

```

Inside MATLAB you will find:

```matlab
>> load('matfile.mat')
>> cell

cell =

  2×1 cell array

    {1×1 struct}
    {1×1 struct}
```

Read and write behavior for struct arrays is different. For struct arrays we use the `MatlabStructArray` type. You can also write with MAT.jl using Dict arrays `AbstractArray{<:AbstractDict}` if all the Dicts have equal keys, which will automatically convert internally to `MatlabStructArray`.

```julia
sarr = Dict{String, Any}[
    Dict("x"=>1.0, "y"=>2.0),
    Dict("x"=>3.0, "y"=>4.0)
]
matwrite("matfile.mat", Dict("s" => sarr))
# which is the same as:
matwrite("matfile.mat", Dict("s" => MatlabStructArray(sarr)))
# which is the same as:
matwrite("matfile.mat", Dict("s" => MatlabStructArray(["x", "y"], [[1.0, 3.0], [2.0, 4.0]])))
```

Now you'll find the following inside MATLAB:

```matlab
>> load('matfile.mat')
>> s

s =

[2x1 struct, 576 bytes]
x: 1
y: 2
```

Note that when you read the file again, you'll find the `MatlabStructArray`, which you can convert back to the Dict array with `Array`:

```julia
julia> sarr = matread("matfile.mat")["struct_array"]
MatlabStructArray{1} with 2 columns:
 "x": Any[1.0, 3.0]
 "y": Any[2.0, 4.0]

julia> sarr["x"]
2-element Vector{Any}:
 1.0
 3.0

julia> Array(sarr)
2-element Vector{Dict{String, Any}}:
 Dict("x" => 1.0, "y" => 2.0)
 Dict("x" => 3.0, "y" => 4.0)

```

Note that before v0.11 MAT.jl will read struct arrays as a Dict with concatenated arrays in the fields/keys, which is equal to `Dict(sarr)`.

## Object Arrays

You can write an old class object with the `MatlabClassObject` and arrays of objects with `MatlabStructArray` by providing the class name. These are also the types you obtain when you read files.

> Please note that the order of the fields is important for MatlabClassObjects to be read properly in MATLAB. You may get `Warning: Fields of object 'tc' do not match the current constructor definition for class 'TestClass'. The object has been converted to a structure.`. Consider using `OrderedDict` if you have multiple fields.

Write a single class object:
```julia
d = Dict{String,Any}("foo" => 5.0)
obj = MatlabClassObject(d, "TestClass")
matwrite("matfile.mat", Dict("tc" => obj))
```

A class object array
```julia
class_array = MatlabStructArray(["foo"], [[5.0, "bar"]], "TestClass")
matwrite("matfile.mat", Dict("class_array" => class_array))
```

Also a class object array, but will be converted to `MatlabStructArray` internally:
```julia
class_array = MatlabClassObject[
    MatlabClassObject(Dict{String,Any}("foo" => 5.0), "TestClass"),
    MatlabClassObject(Dict{String,Any}("foo" => "bar"), "TestClass")
]
matwrite("matfile.mat", Dict("class_array" => class_array))
```

A cell array:
```julia
cell_array = Any[
    MatlabClassObject(Dict{String,Any}("foo" => 5.0), "TestClass"),
    MatlabClassObject(Dict{String,Any}("a" => "bar"), "AnotherClass")
]
matwrite("matfile.mat", Dict("cell_array" => cell_array))
```

# Types and conversions

MAT.jl uses the following type conversions from MATLAB types to Julia types:

| MATLAB    | Julia |
| -------- | ------- |
| numerical array | `Array{T}` |
| cell array | `Array{Any}` |
| char array | `String` |
| `struct`  | `Dict{String,Any}`    |
| `struct` array | `MAT.MatlabStructArray`     |
| old class object    | `MAT.MatlabClassObject`    |
| new (opaque) class    | `MAT.MatlabOpaque`    |

A few of the `MatlabOpaque` classes are automatically converted upon reading:

| MATLAB    | Julia |
| -------- | ------- |
| `string`    | `String`    |
| `datetime`    | `Dates.DateTime`    |
| `duration`    | `Dates.Millisecond`    |
| `category`    | `PooledArrays.PooledArray`    |
| `table`    | `MAT.MatlabTable` (or any other table) |

Note that single element arrays are typically converted to scalars in Julia, because MATLAB cannot distinguish between scalars and `1x1` sized arrays.
